%include "asm.inc"

global CreateSleepingTimer
extern AllocHeap
extern FreeHeap

struc TIMERDATA
.time     resd 1
.callback resd 1
.data     resd 1
endstruc

PROC CreateSleepingTimer, 0, dwmsWaitTime, callback,data
	call   AllocHeap, TIMERDATA_size
	mov    esi,eax
	and    eax,eax
	jz     quit
	mov    eax,dwmsWaitTime
	mov    [esi+TIMERDATA.time],eax
	mov    eax,callback
	mov    [esi+TIMERDATA.callback],eax
	mov    eax,data
	mov    [esi+TIMERDATA.data],eax
	invoke CreateThread, 0,0,ThreadSleepCallback, esi, 0, offset dwmsWaitTime
	invoke CloseHandle, eax	
quit:
ENDPROC


PROC ThreadSleepCallback, 0, tdata
	mov    esi,tdata
	invoke Sleep, [esi+TIMERDATA.time] // wait

	call   [esi+TIMERDATA.callback], [esi+TIMERDATA.data] // callback

	call   FreeHeap, esi // free memory
	invoke ExitThread, eax // quit
ENDPROC