%include "asm.inc"

global lvInsertColumnW
global lvInsertItemW
global lvSetTextW
global lvAddItemW
global lvSetDataW
global ColorListView

struc NMHDR
.hwndFrom resd 1
.idFrom resd 1
.code resd 1
endstruc

struc LV_COLUMN
.imask resd 1
.fmt resd 1
.lx resd 1
.pszText resd 1
.cchTextMax resd 1
.iSubItem resd 1
endstruc

struc LV_ITEM
.mask resd 1
.iItem resd 1
.iSubItem resd 1
.state resd 1
.stateMask resd 1
.pszText resd 1
.cchTextMax resd 1
.iImage resd 1
.lParam resd 1
endstruc

struc NMCUSTOMDRAW
.hdr         resd 3
.dwDrawStage resd 1
.hdc         resd 1
.rc          resd 4 ;RECT_size
.dwItemSpec  resd 1
.uItemState  resd 1
.lItemlParam resd 1
endstruc

struc NMLVCUSTOMDRAW
.nmcd        resb NMCUSTOMDRAW_size
.clrText     resd 1
.clrTextBk   resd 1
.iSubItem    resd 1
.dwItemType  resd 1
.clrFace     resd 1
.iIconEffect resd 1
.iIconPhase  resd 1
.iPartId     resd 1
.iStateId    resd 1
.rcText      resd 4 ;RECT_size
.uAlign      resd 1
endstruc

LVCF_WIDTH          equ 0x2
LVCF_TEXT           equ 0x4
LVIF_TEXT           equ 1
LVM_GETITEMCOUNT    equ 0x1004
LVM_INSERTCOLUMNW   equ 0x1000 + 97
LVM_SETITEMW        equ 0x1000 + 76
LVM_INSERTITEMW     equ 0x1000+77
LVM_GETBKCOLOR      equ 0x1000
LVM_GETITEMW        equ 0x1000 + 75
LVIF_PARAM          equ 4
CDDS_PREPAINT       equ 1
CDDS_ITEM           equ 0x10000
CDRF_NOTIFYITEMDRAW equ 0x20
CDDS_ITEMPREPAINT   equ (CDDS_ITEM | CDDS_PREPAINT)
CDRF_DODEFAULT      equ 0
CDRF_NEWFONT        equ 2

PROC lvInsertColumnW, LV_COLUMN_size, hwnd, id, index, caption, width
	LOCAL lvc,LV_COLUMN_size

	lea    esi,lvc
	mov    dword[esi+LV_COLUMN.imask], LVCF_TEXT | LVCF_WIDTH
	mov    eax,width
	mov    dword[esi+LV_COLUMN.lx],eax
	mov    eax,caption
	mov    dword[esi+LV_COLUMN.pszText],eax
	invoke SendDlgItemMessageW, hwnd, id, LVM_INSERTCOLUMNW, index, esi
	%undef hwnd
	%undef id
	%undef index
	%undef caption
	%undef width
ENDPROC


//Returns the index of the new item if successful, or -1 otherwise
PROC lvInsertItemW, LV_ITEM_size, hwnd, id, item, caption
	LOCAL lvitem,LV_ITEM_size

	lea    esi,lvitem
	mov    dword[esi+LV_ITEM.mask], LVIF_TEXT
	mov    eax,item
	mov    dword[esi+LV_ITEM.iItem], eax
	xor    edx,edx
	mov    dword[esi+LV_ITEM.iSubItem], edx
	mov    edx,caption
	mov    [esi+LV_ITEM.pszText], edx
	invoke SendDlgItemMessageW, hwnd, id, LVM_INSERTITEMW, 0, esi
	%undef hwnd
	%undef id
	%undef item
	%undef caption
	%undef lvitem
ENDPROC



PROC lvSetDataW, LV_ITEM_size, hwnd, id, item, subitem, data
	LOCAL lvitem,LV_ITEM_size

	lea    esi,lvitem
	mov    dword[esi+LV_ITEM.mask], LVIF_PARAM
	mov    eax,item
	mov    dword[esi+LV_ITEM.iItem], eax
	mov    edx,subitem
	mov    dword[esi+LV_ITEM.iSubItem], edx
	mov    edx,data
	mov    dword[esi+LV_ITEM.lParam], edx
	invoke SendDlgItemMessageW, hwnd, id, LVM_SETITEMW, 0, esi
	%undef hwnd
	%undef id
	%undef item
	%undef subitem
	%undef data
	%undef lvitem
ENDPROC



PROC lvSetTextW, LV_ITEM_size, hwnd, id, item, subitem, caption
	LOCAL lvitem,LV_ITEM_size

	lea    esi,lvitem
	mov    dword[esi+LV_ITEM.mask], LVIF_TEXT
	mov    eax,item
	mov    dword[esi+LV_ITEM.iItem], eax
	mov    edx,subitem
	mov    dword[esi+LV_ITEM.iSubItem], edx
	mov    edx,caption
	mov    [esi+LV_ITEM.pszText], edx
	invoke SendDlgItemMessageW, hwnd, id, LVM_SETITEMW, 0, esi
	%undef hwnd
	%undef id
	%undef item
	%undef subitem
	%undef caption
	%undef lvitem
ENDPROC


PROC lvAddItemW, LV_ITEM_size, hwnd, id, caption
	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, id, LVM_GETITEMCOUNT,eax,eax
	call   lvInsertItemW, hwnd, id, eax, caption
	%undef hwnd
	%undef id
	%undef caption
ENDPROC


PROC ColorListView, LV_ITEM_size, lParam
	LOCAL lvitem,LV_ITEM_size
	lea    edi,lvitem
	mov    esi,lParam
	%define lParam esi
	%define lvitem edi
	select [lParam+NMCUSTOMDRAW.dwDrawStage]

		case CDDS_PREPAINT
			mov  eax, CDRF_NOTIFYITEMDRAW

		case CDDS_ITEMPREPAINT
			// pnmcd->nmcd.dwItemSpec

			mov    dword[lvitem+LV_ITEM.mask],LVIF_PARAM
			mov    edx,[lParam+NMCUSTOMDRAW.dwItemSpec]
			mov    [lvitem+LV_ITEM.iItem],edx
			xor    eax,eax
			mov    [lvitem+LV_ITEM.iSubItem],eax
			invoke SendMessageW, [lParam+NMHDR.hwndFrom], LVM_GETITEMW,eax,lvitem
			xor    eax,eax
			invoke SendMessageW, [lParam+NMHDR.hwndFrom], LVM_GETBKCOLOR,eax,eax
			mov    ebx,[lvitem+LV_ITEM.lParam] // color index [0,1]
			and    ebx,ebx
			jz    .skip
			xor    eax,0x00100010
		.skip:
			mov    [lParam+NMLVCUSTOMDRAW.clrTextBk],eax
			mov    eax,CDRF_NEWFONT

		default
			mov  eax,CDRF_DODEFAULT

	endselect

ENDPROC
