%include "asm.inc"
%include "rsrc.inc"

struc RECT
.left resd 1
.top resd 1
.right resd 1
.bottom resd 1
endstruc


struc WINDOWPLACEMENT
.length           resd 1
.flags            resd 1
.showCmd          resd 1
.ptMinPosition    resd 2
.ptMaxPosition    resd 2
.rcNormalPosition resd 4
endstruc

WM_INITDIALOG equ 0x110
WM_VSCROLL    equ 0x115
WM_CLOSE      equ 0x010
LB_ADDSTRING  equ 0x180
WM_SIZE       equ 0x005
SW_HIDE       equ 0x000
SW_SHOW       equ 0x005
SB_BOTTOM     equ 7

global LogDlgCreate
global LogDlgDestroy
global LogDlgIsVisible
global LogDlgToggleVisible
global LogDlgAddString
global $wszPropLog
extern $g_hInstance


PROC LogDlgCreate, 0, parent, show
	invoke CreateDialogParamW, [$g_hInstance], IDD_DLG_LOG, parent, LogDlgProc, show
	invoke SetPropW, parent, $wszPropLog, eax
	%undef parent
	%undef show
ENDPROC



PROC LogDlgDestroy, 0, parent
	invoke GetPropW, parent, $wszPropLog
	mov    esi,eax
	invoke RemovePropW, parent, $wszPropLog
	invoke EndDialog, esi, 0
	%undef parent
ENDPROC


PROC LogDlgIsVisible, 0, parent
	invoke GetPropW, parent, $wszPropLog
	invoke IsWindowVisible, eax
	%undef parent
ENDPROC


PROC LogDlgToggleVisible, 0, parent
	invoke GetPropW, parent, $wszPropLog
	mov    esi,eax
	invoke IsWindowVisible, esi
	xor    dl,dl
	and    eax,eax
	setz   dl
	mov    eax,SW_SHOW
	and    al,dl
	invoke ShowWindow, esi, eax
	%undef parent
ENDPROC



PROC LogDlgAddString, 0, parent, lpwstr
	invoke GetPropW, parent, $wszPropLog
	mov    edi,eax
	invoke SendDlgItemMessageW, edi, IDC_LST1, LB_ADDSTRING, 0, lpwstr
	invoke SendDlgItemMessageW, edi, IDC_LST1, WM_VSCROLL, SB_BOTTOM, 0
	%undef parent
	%undef lpwstr
ENDPROC


PROC LogDlgProc, WINDOWPLACEMENT_size, hwnd, msg, wParam, lParam
	LOCAL wp, WINDOWPLACEMENT_size
	LOCAL rc, 0

	select msg

		case WM_INITDIALOG
			lea    esi,wp
			mov    dword[esi+WINDOWPLACEMENT.length],WINDOWPLACEMENT_size
			invoke GetWindowPlacement, hwnd, esi
			mov    eax,lParam
			mov    [esi+WINDOWPLACEMENT.showCmd],eax
			invoke SetWindowPlacement, hwnd, esi
			invoke ShowWindow,hwnd,lParam
			mov    eax,1

		case WM_SIZE
			lea   esi,rc
			invoke GetClientRect, hwnd,esi
			invoke GetDlgItem,hwnd,IDC_LST1
			invoke MoveWindow, eax,0,0,[esi+RECT.right],[esi+RECT.bottom],1

		case WM_CLOSE
			invoke ShowWindow, hwnd, SW_HIDE

		default
			xor    eax,eax

	endselect
	%undef hwnd
	%undef msg
	%undef wParam
	%undef lParam
	%undef rc
ENDPROC


segment .data
$wszPropLog db "\LLOGDLG"
