%include "asm.inc"
%define __Variant2Str_defined__
%include "variant.inc"
$use "Variant2Str.obj"


%define BSS_STRING_TCHARS 260

// unhandled types
_VT_EMPTY:
	invoke lstrcpyW,$retstr,"\LVT_EMPTY"
	xor   eax,eax
	ret
_VT_NULL:
	invoke lstrcpyW,$retstr,"\LVT_NULL"
	xor   eax,eax
	ret
_VT_VARIANT:
	invoke lstrcpyW,$retstr,"\LVT_VARIANT"
	xor   eax,eax
	ret
_VT_DECIMAL:
	invoke lstrcpyW,$retstr,"\LVT_DECIMAL"
	xor   eax,eax
	ret
_VT_VOID:
	invoke lstrcpyW,$retstr,"\LVT_VOID"
	xor   eax,eax
	ret
_VT_HRESULT:
	invoke lstrcpyW,$retstr,"\LVT_HRESULT"
	xor   eax,eax
	ret
_VT_PTR:
	invoke lstrcpyW,$retstr,"\LVT_PTR"
	xor   eax,eax
	ret
_VT_SAFEARRAY:
	invoke lstrcpyW,$retstr,"\LVT_SAFEARRAY"
	xor   eax,eax
	ret
_VT_CARRAY:
	invoke lstrcpyW,$retstr,"\LVT_CARRAY"
	xor   eax,eax
	ret
_VT_USERDEFINED:
	invoke lstrcpyW,$retstr,"\LVT_USERDEFINED"
	xor   eax,eax
	ret
_VT_LPSTR:
	invoke lstrcpyW,$retstr,"\LVT_LPSTR"
	xor   eax,eax
	ret
_VT_LPWSTR:
	invoke lstrcpyW,$retstr,"\LVT_LPWSTR"
	xor   eax,eax
	ret
_VT_FILETIME:
	invoke lstrcpyW,$retstr,"\LVT_FILETIME"
	xor   eax,eax
	ret
_VT_BLOB:
	invoke lstrcpyW,$retstr,"\LVT_BLOB"
	xor   eax,eax
	ret
_VT_STREAM:
	invoke lstrcpyW,$retstr,"\LVT_STREAM"
	xor   eax,eax
	ret
_VT_STORAGE:
	invoke lstrcpyW,$retstr,"\LVT_STORAGE"
	xor   eax,eax
	ret
_VT_STREAMED_OBJECT:
	invoke lstrcpyW,$retstr,"\LVT_STREAMED_OBJECT"
	xor   eax,eax
	ret
_VT_STORED_OBJECT:
	invoke lstrcpyW,$retstr,"\LVT_STORED_OBJECT"
	xor   eax,eax
	ret



_VT_BLOB_OBJECT:
	invoke lstrcpyW,$retstr,"\LVT_BLOB_OBJECT"
	xor   eax,eax
	ret
_VT_CF:
	invoke lstrcpyW,$retstr,"\LVT_CF"
	xor   eax,eax
	ret
_VT_CLSID:
	invoke lstrcpyW,$retstr,"\LVT_CLSID"
	xor   eax,eax
	ret
_VT_R8:
	cdecl swprintf,$retstr,"\LVT_R8:0x%X",[esi+VARIANT.dblVal]
	xor   eax,eax
	ret
_VT_CY:
	cdecl swprintf,$retstr,"\LVT_CY:0x%X",[esi+VARIANT.cyVal]
	xor   eax,eax
	ret
_VT_DATE:
	cdecl swprintf,$retstr,"\LVT_DATE:0x%X",[esi+VARIANT.date]
	xor   eax,eax
	ret
_VT_DISPATCH:
	cdecl swprintf,$retstr,"\LVT_DISPATCH:0x%X",[esi+VARIANT.pdispVal]
	xor   eax,eax
	ret
_VT_ERROR:
	cdecl swprintf,$retstr,"\LVT_ERROR:0x%X",[esi+VARIANT.scode]
	xor   eax,eax
	ret
_VT_UNKNOWN:
	cdecl swprintf,$retstr,"\LVT_UNKNOWN:0x%X",[esi+VARIANT.punkVal]
	xor   eax,eax
	ret

/////////////////////////////////////////////
// converts variant value into wide string //
/////////////////////////////////////////////

global Variant2Str
PROC Variant2Str, 0, lpvar
	mov   esi,lpvar
	xor   eax,eax
	mov   edi,$retstr     // empty the return string
	mov   dword[edi],0
	and   esi,esi
	jz   .quit            // quit if lpvar is null

	mov   edi,offsets     // function offsets
	xor   ecx,ecx
	mov   cx,[esi+VARIANT.vt]
;mov eax,ecx
	cmp   cx,72
	ja   .quit            // greather than last supported type

	mov   ecx,[edi+4*ecx] // get function pointer
	and   ecx,ecx
	jz   .quit            // type not supported
;push ecx
;cdecl printf,"vt:%d calling fn 0x%X%c%c",eax,ecx,13,10
;pop ecx
	call  ecx

.quit
;	mov   eax,$retstr
ENDPROC

///////////////////////////////////////
// byte, word, dword [signed/unsigned]
///////////////////////////////////////
_VT_I1:
	mov  al,[esi+VARIANT.cVal]
	jmp  byte_signed
_VT_UI1:
	mov  al,[esi+VARIANT.bVal]
	jmp  byte_unsigned
_VT_I2:
	mov  ax,[esi+VARIANT.iVal]
	jmp  word_signed
_VT_UI2:
	mov  ax,[esi+VARIANT.uiVal]
	jmp  word_unsigned
_VT_I4:
	mov  eax,[esi+VARIANT.lVal]
	jmp  dword_signed
_VT_UI4:
	mov  eax,[esi+VARIANT.ulVal]
	jmp  dword_unsigned
_VT_INT:
	mov  eax,[esi+VARIANT.intVal]
	jmp  dword_signed
_VT_UINT
	mov  eax,[esi+VARIANT.uintVal]
	jmp  dword_unsigned
///////////////////////////////////////
//
//////////////////////////////////////
_VT_I8:
	lea   eax,[esi+VARIANT.llVal]
	cdecl swprintf,$retstr,"\L%ll",eax/////////////////// fix me!
	mov   eax,$retstr
	ret
_VT_UI8:
	lea   eax,[esi+VARIANT.ullVal]
	cdecl swprintf,$retstr,"\L%ul",eax/////////////////// fix me!
	mov   eax,$retstr
	ret
///////////////////////////////////////
// string
///////////////////////////////////////
_VT_BSTR:
	mov  eax,[esi+VARIANT.bstrVal]
	and  eax,eax
	jz  .quit
	invoke lstrcpynW,$retstr,eax,BSS_STRING_TCHARS
//	invoke SysFreeString,[esi+VARIANT.bstrVal]
	mov   eax,$retstr
.quit
	ret




_VT_R4:                // fltVal
	mov   eax,[esi+VARIANT.fltVal]
	cdecl swprintf,$retstr,"\L%f",eax
	mov   eax,$retstr
	ret
_VT_BOOL:              // 
	and    word[esi+VARIANT.boolVal],0
	mov    edx,$szFalse
	jz    .th
	mov    edx,$szTrue
.th
	invoke lstrcpyW,$retstr,edx
	mov   eax,$retstr
	ret





byte_signed:
	cdecl swprintf, $retstr, "\L%d", eax
	mov   eax,$retstr
	ret
byte_unsigned:
	cdecl swprintf, $retstr, "\L%l", eax
	mov   eax,$retstr
	ret
word_signed:
	cdecl swprintf, $retstr, "\L%d", eax
	mov   eax,$retstr
	ret
word_unsigned:
	cdecl swprintf, $retstr, "\L%l", eax
	mov   eax,$retstr
	ret
dword_signed:
	cdecl swprintf, $retstr, "\L%d", eax
	mov   eax,$retstr
	ret
dword_unsigned:
	cdecl swprintf, $retstr, "\L%l", eax
	mov   eax,$retstr
	ret










// =======================================================
   segment .data
// =======================================================
offsets:

dd _VT_EMPTY             // 
dd _VT_NULL              // 
dd _VT_I2                // iVal
dd _VT_I4                // lVal
dd _VT_R4                // fltVal
dd _VT_R8                // dblVal
dd _VT_CY                // cyVal
dd _VT_DATE              // date
dd _VT_BSTR              // bstrVal
dd _VT_DISPATCH          // pdispVal
dd _VT_ERROR             // scode
dd _VT_BOOL              // boolVal
dd _VT_VARIANT           // 
dd _VT_UNKNOWN           // punkVal
dd _VT_DECIMAL           // 
dd 0
dd _VT_I1                // cVal
dd _VT_UI1               // bVal
dd _VT_UI2               // uiVal
dd _VT_UI4               // ulVal
dd _VT_I8                // llval
dd _VT_UI8               // ullVal
dd _VT_INT               // intVal
dd _VT_UINT              // uintVal
dd _VT_VOID              // 
dd _VT_HRESULT           // 
dd _VT_PTR               // 
dd _VT_SAFEARRAY         // 
dd _VT_CARRAY            // 
dd _VT_USERDEFINED       // 
dd _VT_LPSTR             // 
dd _VT_LPWSTR            // 
times (64-31-1) dd 0
dd _VT_FILETIME          // 
dd _VT_BLOB              // 
dd _VT_STREAM            // 
dd _VT_STORAGE           // 
dd _VT_STREAMED_OBJECT   // 
dd _VT_STORED_OBJECT     // 
dd _VT_BLOB_OBJECT       // 
dd _VT_CF                // 
dd _VT_CLSID             // 
////////////////////////////////////////
// _VT_VECTOR           0x1000 // 
// _VT_ARRAY            0x2000 // parray
// _VT_BYREF            0x4000 // 
// _VT_RESERVED         0x8000 // 
// _VT_ILLEGAL          0xffff // 
// _VT_ILLEGALMASKED    0xfff  // 
// _VT_TYPEMASK         0xfff  // 


$szFalse db "\LFALSE"
$szTrue  db "\LTRUE"

// =======================================================
   segment .bss
// =======================================================
$retstr resw BSS_STRING_TCHARS

