%include "WMI Browser.inc"
%include "CWbemObjectSink.inc"
%include "LogDlg.inc"

//$use "uuid.lib"
$use "WmiViewerLib.lib"



// receiving notifications:
// call IWbemServices::ExecNotificationQuery &IEnumWbemClassObject** ppEnum
// call in loop ppEnum.Next  IWbemClassObject** ppObjects




%macro SetStatusText 1-2
	%if %0=1
	invoke SendDlgItemMessageW, [$g_hwnd], IDC_SBR1, SB_SETTEXTW, SBT_NOBORDERS, %1
	%else
	invoke SendDlgItemMessageW, %1, IDC_SBR1, SB_SETTEXTW, SBT_NOBORDERS, %2
	%endif
%endm



// to do  IWbemServices::CreateClassEnum

global $g_hInstance
global $g_hHeap
global $wszComboWProp
global $wszInitialClassProp

segment .bss
$g_hInstance  resd 1
$g_hHeap      resd 1
$g_pService   resd 1
$g_hwnd       resd 1
$g_hThread    resd 1
segment .text



// EnumProperties(pwstrClassName, dwFlags, lpThData)
// InsertListItem(lpThData, lpBstr)
// ShowBstrArray(lpThData)

main:

	invoke InitCommonControls
	invoke GetProcessHeap
	mov    [$g_hHeap],eax
	invoke GetModuleHandleW,0
	mov    [$g_hInstance],eax
	invoke DialogBoxParamW, eax,IDD_DLG1,0,DlgProc,0
	invoke ExitProcess,0
	ret
//////////////////////////////////////////////////////////
// main dialog handler
//////////////////////////////////////////////////////////

//DlgProc
//	onInitDialog
//	onInitMenu
//	onCommand
//	onEnumPropertiesStart
//	onNotify
//		ScrollListToTab
//	onSize
//	onLeftButtonDown
//	onMouseMove
//	onLeftButtonUp
//	onClose
//	onEnumPropertiesStart
//	onEnumPropertiesEnd


PROC DlgProc, 4, hwnd, msg, wParam, lParam
	LOCAL temp
	select msg

		case WM_INITDIALOG
			call  onInitDialog, hwnd, wParam, lParam

		case WM_INITMENU // wParam - hMenu
			call  onInitMenu, hwnd, wParam, lParam

		case WM_COMMAND
			call   onCommand, hwnd, wParam, lParam

		case WM_NOTIFY
			call  onNotify, hwnd, wParam, lParam

		case WM_CLOSE
			call   onClose, hwnd, wParam, lParam

		case WM_SIZE
			call   onSize, hwnd, wParam, lParam

		case WM_USER_ENUM_PROPS_START  // thread data: global memory with window handle
			call onEnumPropertiesStart, hwnd, wParam, lParam

		case WM_USER_ENUM_PROPS_DONE
			call onEnumPropertiesEnd, hwnd, wParam, lParam

		case WM_LBUTTONDOWN
			call onLeftButtonDown, hwnd, wParam, lParam

		case WM_MOUSEMOVE
			call onMouseMove, hwnd, wParam, lParam

		case WM_LBUTTONUP
			call onLeftButtonUp, hwnd, wParam, lParam

		case WM_USER_ENUM_CLASSES_DONE
			mov    esi,$g_hThread
			invoke CloseHandle,[esi]
			xor    eax,eax
			mov    dword[esi],eax
			SetStatusText "\LReady"
			call   LogDlgAddString,hwnd, "\LReady"

			// select last viewed class
			invoke GetPropW, hwnd, $wszInitialClassProp
			mov    esi,eax
			and    eax,eax
			jz    .noinitclass
			invoke SendDlgItemMessageW, hwnd, IDC_CBO1, CB_FINDSTRINGEXACT, -1, esi
			invoke SendDlgItemMessageW, hwnd, IDC_CBO1, CB_SETCURSEL, eax, 0
			call   FreeHeap, esi
			invoke RemovePropW, hwnd, $wszInitialClassProp
			call   onEnumPropertiesStart, hwnd, wParam, lParam
.noinitclass:

		default
			xor    eax,eax

	endselect
	%undef msg
	%undef hwnd
	%undef wParam
	%undef lParam
	%undef temp
ENDPROC

//////////////////////////////////////////////////////////
// onLeftButtonDown - show vertical splitter as dotted line
//////////////////////////////////////////////////////////

segment .data
$dotPatternBmp: dw 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55
segment .text

PROC onLeftButtonDown, 0, hwnd, wParam, lParam

	invoke GetCapture
	cmp    eax,hwnd
	je     near .quit // invalid event

	// to do: check mouse position and change cursor
	mov    esi,lParam
	and    esi,0x0000FFFF
	invoke GetPropW, hwnd, $wszComboWProp
	add    eax, 4
	cmp    esi, eax
	jb     near .quit

	mov    eax,[$hCursorSize]
	invoke SetCursor, eax

	call   AllocHeap, SPLITTERDATA_size
	mov    edi,eax
	and    eax,eax
	jz    .quit
	invoke SetPropW, hwnd, $wszSplitterProp, edi
	invoke GetClientRect, hwnd, offset [edi+SPLITTERDATA.hbr]

	mov    eax,lParam
	and    eax,0x0000FFFF
	mov    [edi+SPLITTERDATA.splpos], eax
	mov    [edi+SPLITTERDATA.splstart], eax
	invoke CreateBitmap, 8, 8, 1, 1, $dotPatternBmp
	mov    [edi+SPLITTERDATA.hbm], eax
	invoke CreatePatternBrush, eax
	mov    [edi+SPLITTERDATA.hbr], eax

	call   DrawSplitter, hwnd, edi // draw splitter (xor)

	invoke SetCapture, hwnd

.quit:
	%undef hwnd
	%undef wParam
	%undef lParam
	%undef rc
ENDPROC

//////////////////////////////////////////////////////////
// onMouseMove - move splitter line
//////////////////////////////////////////////////////////

PROC onMouseMove, 4, hwnd, wParam, lParam
	LOCAL  hCursor
	mov    eax,[$hCursorArrow]
	mov    hCursor,eax

	invoke GetPropW, hwnd, $wszSplitterProp
	mov    edi,eax

	invoke GetCapture
	cmp    eax,hwnd
	je    .move

	// change cursor
	mov    esi,lParam
	and    esi,0x0000FFFF
	invoke GetPropW, hwnd, $wszComboWProp
	add    eax, 4
	cmp    esi, eax
	jb    .setcursor
	add    eax,4
	cmp    esi, eax
	ja    .setcursor
	// check y

	mov    eax,[$hCursorSize]
	mov    hCursor,eax
.setcursor:
	invoke SetCursor, hCursor


	jmp   .quit
	
.move:
	and    edi,edi
	jz    .quit
	call   DrawSplitter, hwnd, edi // remove splitter (xor)
	mov    eax,lParam
	and    eax,0x0000FFFF
	xor    edx,edx
	test   ax,0x8000
	cmovnz eax,edx
	mov    edx,90
	cmp    eax,edx
	cmovb  eax,edx

	mov    [edi+SPLITTERDATA.splpos], eax
	call   DrawSplitter, hwnd, edi // draw splitter at new position
;	mov    eax,1
.quit:
	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// onLeftButtonUp - remove splitter and resize combo box
//////////////////////////////////////////////////////////

PROC onLeftButtonUp, 0, hwnd, wParam, lParam
	invoke GetCapture
	cmp    eax,hwnd
	jne    near .quit
	invoke GetPropW, hwnd, $wszSplitterProp
	mov    edi,eax
	and    eax,eax
	jz    .quit
	invoke ReleaseCapture
	call   DrawSplitter, hwnd, edi // remove splitter (xor)

	invoke DeleteObject, [edi+SPLITTERDATA.hbr]
	invoke DeleteObject, [edi+SPLITTERDATA.hbm]

	invoke GetPropW, hwnd, $wszComboWProp // update menu width
	mov    edx,[edi+SPLITTERDATA.splpos]
	sub    edx,[edi+SPLITTERDATA.splstart]
	jz    .free
	add    eax,edx
	invoke SetPropW, hwnd, $wszComboWProp, eax
.free:
	call   FreeHeap, edi
	invoke RemovePropW, hwnd, $wszSplitterProp
	call   onSize, hwnd, wParam, lParam

.quit:
	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// DrawSplitter
//////////////////////////////////////////////////////////

PROC DrawSplitter, 64, hwnd, spldata
	LOCAL stri,64

	mov    edi,spldata
	%define hdc ebx
	%define x   esi
	invoke GetDC, hwnd
	mov    hdc,eax
	mov    x,  [edi+SPLITTERDATA.splpos]
	sub    x,1

	invoke SetBrushOrgEx, hdc, x, 0, offset stri
	invoke SelectObject, hdc, [edi+SPLITTERDATA.hbr]
	push   eax
PATINVERT equ 0x5A0049
	invoke PatBlt, hdc, x, 0, 4, [edi+SPLITTERDATA.clientH], PATINVERT
	pop    eax
	invoke SelectObject, hdc, eax
	lea    esi,stri
	invoke SetBrushOrgEx, hdc, [esi], [esi+4], 0 // restore
	invoke ReleaseDC, hwnd, hdc
cdecl swprintf, offset stri, "\L%d", [edi+SPLITTERDATA.splpos]
invoke SetWindowTextW,hwnd, offset stri

.quit:
	%undef hwnd
	%undef spldata
	%undef hdc
ENDPROC

//////////////////////////////////////////////////////////
// onInitDialog
//////////////////////////////////////////////////////////

PROC onInitDialog, 4, hwnd, wParam, lParam
	LOCAL temp

	invoke LoadIconW, [$g_hInstance], 101
	invoke SendMessageW, hwnd, WM_SETICON, 0, eax
	invoke LoadCursorW, 0, IDC_ARROW
	mov    [$hCursorArrow],eax
	invoke LoadCursorW, [$g_hInstance], IDC_SIZELR
	mov    [$hCursorSize], eax


	invoke SetPropW, hwnd,$wszComboWProp, 180
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_STYLE, LVS_EX_STYLE
	call   lvInsertColumnW, hwnd, IDC_LSV1, 0, "\LProperty", 160
	call   lvInsertColumnW, hwnd, IDC_LSV1, 1, "\LValue", 160

	invoke LoadMenuW, [$g_hInstance], $wszMainMenu
	invoke SetMenu, hwnd, eax

	call   LogDlgCreate, hwnd, SW_HIDE
	call   LogDlgAddString,hwnd, "\LLoading Settings..."
	call   Application_LoadSettings, hwnd
	call   onSize,hwnd,0,0
	mov    eax,hwnd
	mov    [$g_hwnd],eax

	SetStatusText "\LInitializing COM Library..."
	call   LogDlgAddString,hwnd, "\LInitializing COM Library"
	call   wmiInit, hwnd

	SetStatusText "\LRunning Class Enumerator..."
	call   LogDlgAddString,hwnd, "\LStarting WMI Class Enumerator..."
	invoke  CreateThread, 0,0,ThreadEnumClasses, hwnd, 0, offset temp
	mov     [$g_hThread],eax
	SetStatusText "\LEnumerating classes"
	call   LogDlgAddString,hwnd, "\LEnumerating..."

	// subclass the tab control to receive updown control notifications
	invoke GetDlgItem, hwnd, IDC_TAB1
	mov    esi,eax
	invoke SetWindowLongW, esi, GWL_WNDPROC, TabSubclassProc
	invoke SetPropW, esi, $wszTabSubclassProcProp, eax

	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// onInitMenu
//////////////////////////////////////////////////////////

PROC onInitMenu, 4, hwnd, wParam, lParam
	LOCAL  hMenu
	call   LogDlgIsVisible, hwnd
	shl    eax,3 // MF_CHECKED=0x8
	mov    esi,eax
	invoke GetMenu, hwnd
	mov    hMenu,eax
	invoke CheckMenuItem, eax, IDM_SHOWLOG, esi

	// can save class list?
	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, IDC_CBO1, CB_GETCOUNT, eax, eax
	xor    ecx,ecx
	mov    edx,ecx
	inc    edx     // MF_GRAYED
	and    eax,eax
	cmovz  ecx,edx
	inc    eax
	cmovz  ecx,edx
	invoke EnableMenuItem, hMenu, IDM_SAVECLASSES, ecx

	// can save properties?
	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_GETITEMCOUNT, eax, eax
	xor    ecx,ecx
	mov    edx,ecx
	inc    edx     // MF_GRAYED
	and    eax,eax
	cmovz  ecx,edx
	invoke EnableMenuItem, hMenu, IDM_SAVEPROPS, ecx



	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// onCommand
//
// wParam.lo - control id
// wParam.hi - notification code (menu:0, accel:1)
// lParam    - control handle
//////////////////////////////////////////////////////////

PROC onCommand, 8, hwnd, wParam, lParam
	LOCAL NOTIFY
	LOCAL CONTROLID

	mov    eax, wParam
	mov    edx,eax
	and    edx,0xFFFF
	mov    CONTROLID,edx
	shr    eax,16
	mov    NOTIFY,eax

	select CONTROLID

		case IDCANCEL // ESC key
			invoke PostMessageW, hwnd, WM_CLOSE, eax,eax

		case IDC_CBO1 // combo

			select NOTIFY
				case CBN_SELCHANGE
					invoke PostMessageW, hwnd, WM_USER_ENUM_PROPS_START, eax,eax
			endselect

		case IDM_SHOWLOG // menu
			call LogDlgToggleVisible, hwnd

		case IDM_SHOWALLPROPS
			call ToggleShowAllProps, hwnd

		case IDM_SAVECLASSES
			call SaveClasses, hwnd

		case IDM_SAVEPROPS
			call SaveProperties, hwnd

	endselect

	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC


PROC ToggleShowAllProps, 0, hwnd
	invoke GetMenu, hwnd
	mov    esi,eax
	call   isMenuItemChecked, esi, IDM_SHOWALLPROPS
	xor    eax,1
	shl    eax,3
//	or     eax,MF_BYCOMMAND
	invoke CheckMenuItem, esi, IDM_SHOWALLPROPS, eax
	call   onEnumPropertiesStart, hwnd, eax, eax
	%undef hwnd
ENDPROC
//////////////////////////////////////////////////////////
// onNotify
//////////////////////////////////////////////////////////

PROC onNotify, 0, hwnd, wParam, lParam
	mov   esi,lParam

	select [esi+NMHDR.code]


		case NM_CUSTOMDRAW
			cmp    dword[esi+NMHDR.idFrom],IDC_LSV1
			jne   .nolv
			call   ColorListView, lParam
			invoke SetWindowLongW,hwnd,DWL_MSGRESULT,eax
			mov    eax,1
		.nolv:


		case TCN_SELCHANGE
			cmp dword[esi+NMHDR.idFrom],IDC_TAB1
			jnz .notcnsh
			call ScrollListToTab, hwnd
		.notcnsh:

		// to fix
		case UDN_DELTAPOS
			mov    edi,[esi+NM_UPDOWN.iPos]
			xor    eax,eax
			mov    ecx,eax
			dec    eax     // eax = -1
			inc    ecx     // ecx = +1
			cmp    dword[esi+NM_UPDOWN.iDelta],0
			cmovng ecx,eax

			add    edi,ecx // -1 or 1
		//	mov    dword[esi+NM_UPDOWN.iPos],eax
			invoke GetDlgItem, hwnd, IDC_TAB1
			mov    esi,eax
			invoke GetWindowLongW, esi, GWL_WNDPROC
			invoke CallWindowProcW, eax, esi, TCM_SETCURSEL, edi,1
			call   ScrollListToTab, hwnd

	endselect

	%undef hwnd
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// onSize
//////////////////////////////////////////////////////////

PROC onSize, 24+4, hwnd, wParam, lParam
	LOCAL rc, 16
	LOCAL comboW
	LOCAL lvleft
	LOCAL cHwnd

	%define LFTMARGIN 4
	%define RIGMARGIN 4
	%define SPACE     3
	%define TOPMARGIN 20

	invoke GetPropW, hwnd, $wszComboWProp
	mov    comboW,eax

	lea    esi,rc
	// resize status bar
	invoke GetDlgItem, hwnd, IDC_SBR1
	mov    cHwnd,eax
	xor    eax,eax
	invoke SendMessageW, cHwnd, WM_SIZE,eax,eax // resize statusbar

	invoke GetClientRect, cHwnd,esi // and get it's size
	mov    ebx,[esi+RECT.bottom]  // statusbar's height

	invoke GetClientRect, hwnd, esi
	sub    dword[esi+RECT.bottom],ebx // adjust statusbar's height

	invoke GetDlgItem, hwnd, IDC_CBO1
	mov    cHwnd,eax
	mov    edx,[esi+RECT.bottom]
	sub    edx,TOPMARGIN
	invoke MoveWindow, cHwnd, LFTMARGIN, TOPMARGIN, comboW, edx, 1

	invoke GetDlgItem, hwnd, IDC_LSV1
	mov    cHwnd,eax
	mov    edx,[esi+RECT.right] // client width
	sub    edx,LFTMARGIN+SPACE+RIGMARGIN-4
	sub    edx,comboW
	mov    ecx,[esi+RECT.bottom] // height
	sub    ecx,TOPMARGIN
	mov    eax,comboW
	add    eax,LFTMARGIN+SPACE
	push   eax, edx
	invoke MoveWindow, cHwnd, eax, TOPMARGIN, edx, ecx, 1

	invoke GetDlgItem, hwnd, IDC_TAB1
	mov    cHwnd,eax
	add    ecx,TOPMARGIN
	pop    edx,eax
	invoke MoveWindow, cHwnd, eax, 0, edx, TOPMARGIN, 1

	%undef wParam
	%undef lParam
	%undef hwnd
	%undef rc
ENDPROC

//////////////////////////////////////////////////////////
// onClose
//////////////////////////////////////////////////////////

PROC onClose, 0, hwnd, wParam, lParam
	call   Application_SaveSettings, hwnd
	mov    esi,$g_hThread
	mov    ebx,[esi]
	xor    eax,eax
	and    ebx,ebx // hThread
	jz    .close
	mov    [$g_hThread],eax // force enumerator thread to exit
	invoke DialogBoxParamW, eax, IDD_DLG2, hwnd, DlgProc2, 0
	invoke CloseHandle, ebx
.close:
	invoke RemovePropW, hwnd, $wszComboWProp
	call   wmiShutdown
	invoke EndDialog, hwnd, eax

	%undef wParam
	%undef lParam
	%undef hwnd
ENDPROC

//////////////////////////////////////////////////////////
// onEnumPropertiesStart
// create thread ThreadEnumProps() and return
//////////////////////////////////////////////////////////

PROC onEnumPropertiesStart, 0, hwnd, wParam, lParam
	// any WMI query pending?
	invoke GetPropW, hwnd, $wszPropThreadData
	and    eax,eax
	jz    .nothprop
	// yes, kill if after 3s
	mov    esi,eax
	call   LogDlgAddString,hwnd, "\LPending WMI Query detected! Terminating in 3s"
	mov    dword[esi+THREADDATA.hwnd],0 // reset hwnd - thread shound terminate
	call   CreateSleepingTimer, 3000, TerminateWmiQuery, esi
	invoke RemovePropW, hwnd, $wszPropThreadData
.nothprop:
	SetStatusText "\LEnumerating properties"
	call   LogDlgAddString,hwnd, "\LStarting Properties enumeration"
	call   AllocHeap,THREADDATA_size // alloc memory for this hwnd for thread [clean in thread]
	and    eax,eax
	jnz   .gaok
	SetStatusText "\LFailed to allocate memory"
	jmp   .quit
.gaok:
	mov    esi,eax
	////////////////////////////
	invoke GetMenu, hwnd
	call   isMenuItemChecked, eax, IDM_SHOWALLPROPS
	mov    [esi+THREADDATA.showall],eax
	////////////////////////////
	mov    eax,hwnd
	mov    [esi+THREADDATA.hwnd],eax
	////////////////////////////
	coinvoke [$g_pService], IWbemServices@QueryInterface, _IID_IWbemServices, offset [esi+THREADDATA.pService]
	and      eax,eax
	jnz     .free
	invoke   SetPropW, hwnd, $wszPropThreadData, esi
	invoke   CreateThread, 0,0, ThreadEnumProps, esi, 0, offset temp
	mov      [esi+THREADDATA.hThread],eax
	and      eax,eax
	jnz     .quit
	coinvoke [esi+THREADDATA.pService], IWbemServices@Release
.free:
	call     FreeHeap, esi
.quit:
	%undef   wParam
	%undef   lParam
	%undef   hwnd
	%undef   temp
ENDPROC

//////////////////////////////////////////////////////////
// onEnumPropertiesEnd
//////////////////////////////////////////////////////////

PROC onEnumPropertiesEnd, 0, hwnd, wParam, lParam
	SetStatusText "\LDone"
	call     LogDlgAddString,hwnd, "\LFinished Properties enumeration"
	mov      esi,lParam
	invoke   IsBadReadPtr, esi, THREADDATA_size
	and      eax,eax
	jnz     .quit
	call     SizeHeap, esi
	cmp      eax,THREADDATA_size
	jne     .quit

	// memory esi is valid
	invoke   CloseHandle,[esi+THREADDATA.hThread]
	// cleanup .bstrClass
	mov      eax,[esi+THREADDATA.bstrClass]
	and      eax,eax
	jz      .nofree
	invoke   SysFreeString, eax
.nofree:
	coinvoke [esi+THREADDATA.pService], IWbemServices@Release
	call     FreeHeap,esi
	invoke   RemovePropW, hwnd, $wszPropThreadData
//	call     LogDlgAddString,hwnd, "\LFreeing thread memory"
	jmp     .quit

.quit:
	%undef wParam
	%undef lParam
	%undef hwnd
ENDPROC
//////////////////////////////////////////////////////////
// dialogbox [cancel,terminate]
// - waiting for class enumerator
//////////////////////////////////////////////////////////

PROC DlgProc2,12,hwnd,msg,wParam,lParam
	select msg

		case WM_INITDIALOG
			invoke SetTimer, hwnd, 100, 333, 0
			mov  eax,1

		case WM_TIMER
			cmp    dword wParam,100
			jnz   .next
			invoke WaitForSingleObject, [$g_hThread], 1
			cmp    eax,WAIT_TIMEOUT
			jnz    .postquit // thread is alive
		.next:

		case WM_COMMAND
			mov    eax, wParam
			cmp    ax,IDCANCEL
			jnz   .nocancel
		.postquit
			invoke PostMessageW, hwnd, WM_CLOSE, eax,eax
		.nocancel:

		case WM_CLOSE
			invoke KillTimer, hwnd, 100
			invoke EndDialog, hwnd, eax

		default
			xor    eax,eax

	endselect

	%undef hwnd
	%undef msg
	%undef wParam
	%undef lParam
ENDPROC

//////////////////////////////////////////////////////////
// initialize WMI
//////////////////////////////////////////////////////////

PROC wmiInit, 0, hwnd

	LOCAL pLocator    // IWbemLocator

	invoke CoInitializeEx, NULL, COINIT_MULTITHREADED

	invoke CoInitializeSecurity, NULL, -1, NULL, NULL, RPC_C_AUTHN_LEVEL_DEFAULT, \
			RPC_C_IMP_LEVEL_IMPERSONATE, NULL, EOAC_NONE, NULL

	invoke CoCreateInstance,_CLSID_WbemAdministrativeLocator, NULL,\
			CLSCTX_INPROC_SERVER, _IID_IWbemLocator, offset pLocator

	// connect to namespace root\cimv2
	coinvoke pLocator, IWbemLocator@ConnectServer,\
		bstr_t("\Lroot\cimv2"),\
		NULL, NULL, NULL,\
		WBEM_FLAG_CONNECT_USE_MAX_WAIT,\
		NULL, NULL, $g_pService

	// release WbemLocator, 
	coinvoke pLocator, IWbemLocator@Release

	%undef pLocator
	%undef hwnd
ENDPROC

//////////////////////////////////////////////////////////
// Shutdown WMI
//////////////////////////////////////////////////////////

wmiShutdown:
	xor      eax,eax
	cmp      eax,[$g_pService]
	je      .norelease
	coinvoke [$g_pService], IWbemServices@Release
.norelease:
	invoke   CoUninitialize
	ret

//////////////////////////////////////////////////////////
// Enumerates all top level WMI classes [thread]
//////////////////////////////////////////////////////////

PROC ThreadEnumClasses, 4, hwnd
	LOCAL    pClsEnum    // IEnumWbemClassObject
	mov      esi,[$g_pService]
	and      esi,esi
	jz      .quit
	// enum all top level classes
	coinvoke esi, IWbemServices@CreateClassEnum,NULL,WBEM_FLAG_DEEP|WBEM_FLAG_FORWARD_ONLY,NULL,offset pClsEnum
	and      eax,eax
	jnz     .quit

	call     EnumClasses, pClsEnum, hwnd
	coinvoke pClsEnum, IEnumWbemClassObject@Release

.quit
	invoke   SendMessageW, hwnd, WM_USER_ENUM_CLASSES_DONE, 0, 0

ENDPROC
%undef pClsEnum
%undef hwnd


PROC EnumClasses, 32, pClsEnum, hwnd // pClsEnum: valid IEnumWbemClassObject

	LOCAL pObject      // IWbemClassObject
	LOCAL retCount
	LOCAL pstrNames
	LOCAL var_name,20  // VARIANT - class name

	// enumerate all sub-classes
.nxtcls:
	coinvoke pClsEnum, IEnumWbemClassObject@Next,\
		WBEM_INFINITE,\
		1,\
		offset pObject,\
		offset retCount

	and  eax,eax
	jnz  near .quit

	// pObject - IWbemClassObject class
	// we call GetNames to enumerate system properties
	// if property "__CLASS" found - insert class name

	lea      esi,var_name
	coinvoke pObject, IWbemClassObject@Get, "\L__CLASS",NULL, esi, NULL,NULL
	and      eax,eax
	jnz     .noshow
	call     Variant2Str,esi
	and      eax,eax
	jz      .noinsert
	invoke   SendDlgItemMessageW, hwnd, IDC_CBO1, CB_ADDSTRING, 0, eax
.noinsert:
	invoke   VariantClear,esi


.noshow:
	coinvoke pObject, IWbemClassObject@Release
	jmp .nxtcls

.quit
ENDPROC

%undef hwnd
%undef pClsEnum
%undef pObject
%undef retCount
%undef pstrNames
%undef var_name

//////////////////////////////////////////////////////////
// enumerate properties from given class - 
// - selected item in combo box IDC_CBO1
//////////////////////////////////////////////////////////

PROC ThreadEnumProps, 256, lpThData

	LOCAL  txt,256

	xor    eax,eax
	mov    edi,lpThData
	invoke SendDlgItemMessageW, [edi+THREADDATA.hwnd], IDC_LSV1, LVM_DELETEALLITEMS,eax,eax
	xor    eax,eax
	invoke SendDlgItemMessageW, [edi+THREADDATA.hwnd], IDC_TAB1, TCM_DELETEALLITEMS,eax,eax
	lea    esi,txt
	invoke SendDlgItemMessageW, [edi+THREADDATA.hwnd], IDC_CBO1, WM_GETTEXT, 100, esi

	// alloc string for method enumerator
	invoke SysAllocString, esi
	mov    [edi+THREADDATA.bstrClass],eax

	call   ConnectClassObject, esi, edi, WBEM_FLAG_FORWARD_ONLY
	call   EnumProperties, edi, WBEM_FLAG_ALWAYS
	invoke PostMessageW, [edi+THREADDATA.hwnd], WM_USER_ENUM_PROPS_DONE, eax,edi

	%undef txt
	%undef lpThData
ENDPROC


//////////////////////////////////////////////////////////
// terminate thread ThreadEnumProps()
//////////////////////////////////////////////////////////

PROC TerminateWmiQuery, 4, lpThData
	LOCAL  exitcode
	mov    esi,lpThData
	mov    edi,[esi+THREADDATA.hThread]

	// cleanup thread interfaces
	invoke SuspendThread, edi
	mov    eax,[esi+THREADDATA.array]
	and    eax,eax
	jz    .no_array
	invoke SafeArrayDestroy,eax
.no_array:
	mov    eax,[esi+THREADDATA.pObject]
	and    eax,eax
	jz    .no_pObject
	coinvoke eax, IWbemClassObject@Release
.no_pObject:
	mov    eax,[esi+THREADDATA.pPropEnum]
	and    eax,eax
	jz    .no_pPropEnum
	coinvoke eax, IEnumWbemClassObject@Release
.no_pPropEnum:
	mov    eax,[esi+THREADDATA.pService]
	and    eax,eax
	jz    .no_pService
	coinvoke eax, IWbemServices@Release
.no_pService:
	// cleanup .bstrClass
	mov      eax,[esi+THREADDATA.bstrClass]
	and      eax,eax
	jz      .nofree
	invoke   SysFreeString, eax
.nofree:

	invoke GetExitCodeThread, edi, offset exitcode
	and    eax,eax
	jz    .skip
	call   LogDlgAddString, [$g_hwnd], "\LTerminating Thread : TerminateWmiQuery"
	invoke TerminateThread, edi, exitcode
	invoke MessageBeep,0
	jmp   .qu
.skip:
	call   LogDlgAddString, [$g_hwnd], "\LTerminating Thread [cancelled]"
.qu:
	invoke PostMessageW, [esi+THREADDATA.hwnd], WM_USER_ENUM_PROPS_DONE, eax,lpThData
ENDPROC
%undef lpThData

//////////////////////////////////////////////////////////
// connect to IEnumWbemClassObject
// THREADDATA.pService must be valid
// THREADDATA.pPropEnum is returned
//////////////////////////////////////////////////////////

PROC ConnectClassObject, 8, pwstrClassName, lpThData, dwFlags
	LOCAL pwszQuery
	LOCAL pwszStatus

	mov    edi,lpThData
	xor    eax,eax
	mov    dword[edi+THREADDATA.pPropEnum],eax
	cmp    dword[edi+THREADDATA.pService],eax
	je     near .quit

;	invoke SysAllocString, pwstrClassName
;	mov    [edi+THREADDATA.bstrClass],eax

	// create query string
	invoke lstrlenW, pwstrClassName
	add    eax,14+1  // "SELECT * FROM " + *pwstrClassName
	add    eax,eax   // wchar
	mov    ebx,eax
	call   AllocHeap, eax
	mov    pwszQuery,eax
	and    eax,eax
	jz     near .quit
	call   lstrcpyW, pwszQuery, "\LSELECT * FROM " // 14 chars
	call   lstrcatW, pwszQuery, pwstrClassName

	// create status text
	add    ebx, 16<<1    // "Executing query "
	call   AllocHeap, ebx
	mov    pwszStatus,eax
	and    eax,eax
	jz    .nostatus
	call   lstrcpyW, pwszStatus, $wszExecutingQuery // 16 chars
	call   lstrcatW, pwszStatus, pwszQuery
	SetStatusText [edi+THREADDATA.hwnd], pwszStatus
	call   LogDlgAddString, [edi+THREADDATA.hwnd], pwszStatus
	call   FreeHeap, pwszStatus
.nostatus:

	// connect
	coinvoke [edi+THREADDATA.pService], IWbemServices@ExecQuery, \
		bstr_t("\LWQL"), \
		bstr_t(dword pwszQuery),\
		dwFlags,\
		NULL,\
		offset [edi+THREADDATA.pPropEnum]

	mov    ebx,eax
	call   FreeHeap, pwszQuery
	and    ebx,ebx
	jz     .quit

	call   wmiError, "\LExecQuery failed: ", ebx
	and    eax,eax
	jz     near .quit
	call   LogDlgAddString, [edi+THREADDATA.hwnd], eax, eax
	call   FreeHeap
.quit:
	%undef pwstrClassName
	%undef lpThData
	%undef dwFlags
	%undef pwszQuery
	%undef pwszStatus
ENDPROC

//////////////////////////////////////////////////////////
// connect to IEnumWbemClassObject
// THREADDATA.pPropEnum must be valid; is released
//////////////////////////////////////////////////////////

PROC EnumProperties, 4, lpThData, dwFlags

	LOCAL retCount
	mov    edi,lpThData
	xor    eax,eax
	mov    dword[edi+THREADDATA.lvColorIndex],eax
	cmp    dword[edi+THREADDATA.pPropEnum],eax
	jz     near .quit

.do_next:

	// get one or more objects starting at the current position in an enumeration
	// changed WBEM_INFINITE to 5000
	mov      dword[edi+THREADDATA.pObject],0
	coinvoke [edi+THREADDATA.pPropEnum], IEnumWbemClassObject@Next,\
		5000,\
		1,\
		offset [edi+THREADDATA.pObject],\
		offset retCount

	and      eax,eax
	jnz     .e_pObject

	//////////// test ////////////
	call   ShowMethods, lpThData

	xor      eax,eax
	mov      [edi+THREADDATA.array],eax

	coinvoke	[edi+THREADDATA.pObject], IWbemClassObject@GetNames, \
		NULL,\
		dwFlags,\
		NULL,\
		offset [edi+THREADDATA.array]

	and    eax,eax
	jnz   .noshow

	call   InsertTab, lpThData
	call   ShowBstrArray, lpThData
	xor    dword[edi+THREADDATA.lvColorIndex],1
	jmp   .do_next // show next

.noshow:
	coinvoke [edi+THREADDATA.pObject], IWbemClassObject@Release
	mov      dword[edi+THREADDATA.pObject],0

.e_pObject:
	coinvoke [edi+THREADDATA.pPropEnum],IEnumWbemClassObject@Release
	mov      dword[edi+THREADDATA.pPropEnum],0

.quit:
	%undef lpThData
	%undef dwFlags
	%undef retCount
ENDPROC

//////////////////////////////////////////////////////////
// enumerates all methods for given class
//////////////////////////////////////////////////////////

PROC ShowMethods, 24, lpThData
	LOCAL bstrMethodName
	LOCAL pInSignature  // IWbemClassObject
	LOCAL pOutSignature // IWbemClassObject
	LOCAL pwszLine
	LOCAL pObject       // IWbemClassObject

	LOCAL item

	mov    edi,lpThData

	// methods already displayed?
	xor    eax,eax
	cmp    dword[edi+THREADDATA.bstrClass],eax
	jz     near .quit

	cmp    dword[edi+THREADDATA.pService],eax
	jz     near .sysfree
	call   LogDlgAddString, [edi+THREADDATA.hwnd], "\LEnumerating methods..."
	call   AllocHeap, 4096
	mov    pwszLine,eax
	and    eax,eax
	jz     near .sysfree

	coinvoke [edi+THREADDATA.pService], IWbemServices@GetObject, \
		[edi+THREADDATA.bstrClass], 0, 0, offset pObject, 0
	and    eax,eax
	jz    .objok
	call   wmiError, "\LGetObject failed: ", eax
	and    eax,eax
	jz     near .free
	call   LogDlgAddString, [edi+THREADDATA.hwnd], eax, eax
	call   FreeHeap
	jmp    near .free
.objok:
	coinvoke pObject, IWbemClassObject@BeginMethodEnumeration, 0
	and    eax,eax
	jz    .startmethod
	call   wmiError, "\LBeginMethodEnumeration failed: ", eax
	and    eax,eax
	jz     near .release
	call   LogDlgAddString, [edi+THREADDATA.hwnd], eax, eax
	call   FreeHeap
	jmp   .release

.startmethod:
	xor    dword[edi+THREADDATA.lvColorIndex],1

.nextmethod:
	xor  eax,eax
	mov  bstrMethodName,eax
	mov  pInSignature,eax
	mov  pOutSignature,eax

	coinvoke  pObject, IWbemClassObject@NextMethod, 0, \
		offset bstrMethodName, offset pInSignature, offset pOutSignature

	and  eax,eax
	jnz  near .nomore

	// do something ...
	call   lvAddItemW, [edi+THREADDATA.hwnd], IDC_LSV1,  "\LMethod:"
	mov    item, eax // save item index

	call   CreateArgumentsStringW, pwszLine, bstrMethodName, pInSignature, pOutSignature
	call   lvSetTextW, [edi+THREADDATA.hwnd], IDC_LSV1, item, 1, pwszLine


	// and cleanup
	invoke SysFreeString, bstrMethodName
	jmp   .nextmethod

.nomore:
	xor    dword[edi+THREADDATA.lvColorIndex],1
	coinvoke  pObject, IWbemClassObject@EndMethodEnumeration

.release
	coinvoke  pObject, IWbemClassObject@Release

.free:
	call   FreeHeap, pwszLine

	// display methods once
.sysfree:
	invoke SysFreeString, [edi+THREADDATA.bstrClass]
	mov    dword[edi+THREADDATA.bstrClass],0

.quit:
	%undef lpThData
	%undef bstrMethodName
	%undef pInSignature
	%undef pOutSignature
	%undef pwszLine
	%undef pObject
	%undef item
ENDPROC

//////////////////////////////////////////////////////////
// creates argument list string in format 
// SetPowerState(CIM_UINT16 PowerState, CIM_DATETIME Time),CIM_UINT16
// pwszLine - output buffor
// bstrMethodName - "SetPowerState"
// pInSignature, pOutSignature - parameters
//////////////////////////////////////////////////////////

PROC CreateArgumentsStringW, 4, pwszLine, bstrMethodName, pInSignature, pOutSignature
	LOCAL arrayNames

	invoke lstrcpyW, pwszLine, bstrMethodName
	invoke lstrcatW, pwszLine, "\L("
	xor    eax,eax
	mov    arrayNames,eax
	mov    ebx,eax          // array index
	cmp    pInSignature,eax
	je     near .doretval   // no input arguments

	coinvoke pInSignature, IWbemClassObject@GetNames, \
		0, WBEM_FLAG_NONSYSTEM_ONLY, 0, offset arrayNames
//	coinvoke pInSignature, IWbemClassObject@GetNames, \
//		0, 0, 0, offset arrayNames

	and    eax,eax
	jnz    near .quit
	mov    esi,arrayNames
	and    esi,esi
	jz     near .quit
	// valid: arrayNames
	test   word[esi+SAFEARRAY.fFeatures],FADF_BSTR
	jz    .freearray // invalid type
	cmp    word[esi+SAFEARRAY.rgsabound + SAFEARRAYBOUND.cElements],0
	je    .freearray // empty array
	mov    edi,[esi+SAFEARRAY.pvData]

.nextarg:
	call   GetArgTypeStringW, pInSignature, [edi] // eax = "CIM_UINT16"
	invoke lstrcatW, pwszLine, eax
	invoke lstrcatW, pwszLine, "\L "
	invoke lstrcatW, pwszLine, [edi]
	add    edi,4
	inc    ebx
	cmp    bx,[esi+SAFEARRAY.rgsabound + SAFEARRAYBOUND.cElements]
	jnb    .freearray
	invoke lstrcatW, pwszLine, "\L, "
	jmp   .nextarg

.freearray:
	invoke SafeArrayDestroy,arrayNames

.doretval
	invoke lstrcatW, pwszLine, "\L)"

	// return value?
	xor    eax,eax
	cmp    pOutSignature,eax
	jz    .quit
	invoke lstrcatW, pwszLine, "\L,"
	call   GetArgTypeStringW, pOutSignature, "\LReturnValue"
	invoke lstrcatW, pwszLine, eax

	// to do: append return type, if any

.quit:
	%undef pwszLine
	%undef bstrMethodName
	%undef pInSignature
	%undef pOutSignature
	%undef arrayNames
	%undef varType
	%undef vtType
ENDPROC

//////////////////////////////////////////////////////////
// convert CIM_* enumeration to string equivalent
//////////////////////////////////////////////////////////

PROC GetArgTypeStringW, 24, pInSignature, bstrArgName

	LOCAL varType, 20 // VARIANT
	LOCAL vtType      // CIMTYPE

	lea    esi,varType
	mov    word[esi+VARIANT.vt],VT_EMPTY
	xor    eax,eax
	mov    vtType,eax
	coinvoke pInSignature, IWbemClassObject@Get, bstrArgName, 0, esi, offset vtType, 0
	invoke VariantClear, esi
	call   vtType2str, vtType

	%undef pInSignature
	%undef bstrArgName
ENDPROC

//////////////////////////////////////////////////////////
// 
//////////////////////////////////////////////////////////

PROC ShowBstrArray, 0, lpThData

	mov    esi,lpThData
	mov    esi,[esi+THREADDATA.array]
	and    esi,esi
	jz     near .quit

	test   word[esi+SAFEARRAY.fFeatures],FADF_BSTR // validate type
	jz     .freearray

	xor    ebx,ebx
	mov    edi,[esi+SAFEARRAY.pvData]

.nextbstr:

	mov    eax,lpThData
	mov    eax,[eax+THREADDATA.hwnd]
	and    eax,eax
	jz    .freearray
	call   InsertListItem, lpThData, [edi+4*ebx]
//added
	invoke SysFreeString,[edi+4*ebx]
	mov    dword[edi+4*ebx],0
	inc    ebx
	cmp    bx,[esi+SAFEARRAY.rgsabound + SAFEARRAYBOUND.cElements]
	jb    .nextbstr


.freearray: // free the SAFEARRAY
	mov    esi,lpThData
	mov    eax,[esi+THREADDATA.array]
	mov    dword[esi+THREADDATA.array],0
	invoke SafeArrayDestroy,eax
.quit:
ENDPROC
%undef lpSafeArray
%undef lpThData

//////////////////////////////////////////////////////////
// inserts an item into list view
//////////////////////////////////////////////////////////

PROC InsertListItem, 24, lpThData, bstrProperty

	LOCAL hwnd
	LOCAL item
	LOCAL var,VARIANT_size

	mov      esi,lpThData
	mov      eax,[esi+THREADDATA.hwnd]
	mov      hwnd,eax
	and      eax,eax
	jz       near .quit

	call     lvAddItemW, hwnd, IDC_LSV1, bstrProperty
	mov      item,eax
	call     lvSetDataW, hwnd, IDC_LSV1, item, 0, [esi+THREADDATA.lvColorIndex]

	// get the property
	xor      eax,eax
	lea      edi,var
	mov      word[edi+VARIANT.vt],VT_EMPTY
	coinvoke [esi+THREADDATA.pObject], IWbemClassObject@Get, bstrProperty, eax, edi, eax,eax
	and      eax,eax
	jnz     .quit
	// convert VARIANT to string
	call     Variant2Str,edi
	and      eax,eax
	jnz      .propok
	// if failed - check for "show not implemented"
	cmp      dword[esi+THREADDATA.showall],0
	jne     .propok
	invoke   SendDlgItemMessageW,[esi+THREADDATA.hwnd], IDC_LSV1, LVM_DELETEITEM, item, 0
	jmp     .cleanup
.propok:
	call     lvSetTextW, hwnd, IDC_LSV1, item, 1, eax

.cleanup:
	invoke   VariantClear,edi
.quit
	%undef lpThData
	%undef bstrProperty
	%undef hwnd
	%undef item
	%undef var
ENDPROC

//////////////////////////////////////////////////////////
// inserts one tab into tab control
//////////////////////////////////////////////////////////

PROC InsertTab, 128, lpThData
	LOCAL  t, TC_ITEM_size
	LOCAL  txt, 64

	lea    esi,t
	mov    dword[esi+TC_ITEM.mask],TCIF_TEXT | TCIF_PARAM
	lea    edi,txt
	mov    [esi+TC_ITEM.pszText],edi

	xor    eax,eax
	mov    edx,lpThData
	mov    edx,[edx+THREADDATA.hwnd]
	and    edx,edx
	jz    .quit
	push   edx
	invoke SendDlgItemMessageW, edx, IDC_LSV1, LVM_GETITEMCOUNT,eax,eax
	mov    [esi+TC_ITEM.lParam],eax
	xor    eax,eax
	pop    edx
	push   edx
	invoke SendDlgItemMessageW, edx, IDC_TAB1, TCM_GETITEMCOUNT,eax,eax
	push   eax
	cdecl  swprintf, edi, "\LEnum %d", eax
	pop    eax
	pop    edx
	invoke SendDlgItemMessageW, edx, IDC_TAB1, TCM_INSERTITEM, eax,esi
.quit:
ENDPROC

%undef lpThData
%undef t
%undef txt
//////////////////////////////////////////////////////////
// scrolls listview to enumeration indexed by
// current selection in tab control
//////////////////////////////////////////////////////////

PROC ScrollListToTab, 64, hwnd
	LOCAL  t, TC_ITEM_size
	LOCAL  item, LV_ITEM_size

	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, IDC_TAB1, TCM_GETCURSEL,eax,eax
	lea    esi,t

	mov    dword[esi+TC_ITEM.mask], TCIF_PARAM
	invoke SendDlgItemMessageW, hwnd, IDC_TAB1, TCM_GETITEM, eax, esi

	mov    eax,[esi+TC_ITEM.lParam]
	mov    esi,eax // this item must be visible
	lea    edi,item
	// unselect all items
	mov    dword[edi+LV_ITEM.imask],LVIF_STATE
	mov    dword[edi+LV_ITEM.state],0
	mov    dword[edi+LV_ITEM.stateMask],LVIS_FOCUSED|LVIS_SELECTED
	mov    dword[edi+LV_ITEM.iItem],0xFFFFFFFF
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_SETITEMSTATE, 0xFFFFFFFF, edi
	// and select the requested
	mov    dword[edi+LV_ITEM.imask],LVIF_STATE
	mov    dword[edi+LV_ITEM.state],0xFFFFFFFF
	mov    dword[edi+LV_ITEM.stateMask],LVIS_FOCUSED|LVIS_SELECTED
	mov    dword[edi+LV_ITEM.iItem],esi

	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_SETITEMSTATE, esi, edi
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_ENSUREVISIBLE, esi, 1
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_GETTOPINDEX,0,0
	sub    esi,eax
	mov    eax,esi
	xor    edx,edx
	mov    ecx,14
	mul    ecx
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_SCROLL, 0,eax

	%undef hwnd
	%undef lpThData
	%undef t
ENDPROC


//////////////////////////////////////////////////////////
// updates status bar text to current count of sub-classes
//////////////////////////////////////////////////////////
%if 0
PROC UpdateStatusText, 256, lpThData
	LOCAL wstrStatus, 256 // 128 characters
	mov    esi,lpThData
	mov    edx,[esi+THREADDATA.hwnd]
	and    edx,edx
	jz    .quit
	lea    edi,wstrStatus
	mov    word[edi],128 // len
	invoke SendDlgItemMessageW, edx, IDC_LSV1, SB_GETTEXT, 0, edi
	xor    ebx,ebx
	xchg   bx,[edi+16<<1] // terminate string after "Executing query "
	invoke lstrcmpW, edi, $wszExecutingQuery
	jne   .quit
	xchg   bx,[edi+16<<1] // restore
	// go to last wide character
	invoke lstrlenW, edi
	dec    eax
	add    eax,eax
	add    edi,edi
	// go to 
	


	%undef hwnd
	%undef lpThData
	%undef lpwStatus
ENDPROC
%endif


//////////////////////////////////////////////////////////
// save to file list of classes
//////////////////////////////////////////////////////////
%define COMBOSTRLEN 1024

PROC SaveClasses, 9<<2, hwnd
	LOCAL  items
	LOCAL  hFile
	LOCAL  lpString
	LOCAL  boolUnicode
	LOCAL  temp
	LOCAL  apiSendMsg
	LOCAL  strNL
	LOCAL  len_nl

	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, IDC_CBO1, CB_GETCOUNT, eax, eax
	mov    items,eax
	and    eax,eax
	jz     near .quit
	inc    eax
	jz     near .quit
	call   FileRequest, hwnd, 1, offset boolUnicode
	and    eax,eax
	jz     near .quit

	xor    eax,eax
	invoke CreateFileW, $wszOpenSavePath,GENERIC_WRITE,FILE_SHARE_READ,eax,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,eax
	mov    hFile,eax
	inc    eax
	jnz   .opened
	invoke MessageBoxW,hwnd,$wszCanNotOpenFile,eax,16
	jmp   .quit
.opened:
	lea    esi,temp // WriteFile bytes_writen

	mov    eax,boolUnicode
	mov    ecx,COMBOSTRLEN
	mov    edx,ecx
	add    edx,edx // COMBOSTRLEN*2
	and    eax,eax // unicode?
	cmovz  ecx,edx // size *2
	call   AllocHeap, ecx
	mov    lpString,eax
	and    eax,eax
	jz     near .closef

	extern SendDlgItemMessageA
	extern SendDlgItemMessageW

	mov    dword apiSendMsg,SendDlgItemMessageA // default ansi
	mov    dword strNL, $ansi_nl // 13,10
	mov    dword len_nl, 2

	xor    ebx,ebx      // ebx - combo string index
	cmp    dword boolUnicode,0
	jz    .next

	mov    dword apiSendMsg,SendDlgItemMessageW // else unicode

	mov    dword strNL, $wcha_nl
	mov    dword len_nl, 4

	push   word 0xFEFF
	mov    eax,esp
	xor    edx,edx
	invoke WriteFile, hFile,eax,2,esi,edx // write unicode header
	pop    eax

.next:
	call   apiSendMsg, hwnd, IDC_CBO1, CB_GETLBTEXT, ebx, lpString
	// eax = strlen

	mov    ecx,eax
	add    ecx,ecx // ecx = strlen*2
	jc    .invalid // CB_ERR
	cmp    dword boolUnicode,0
	cmovnz eax,ecx
	xor    edx,edx
	invoke WriteFile, hFile, lpString, eax, esi, edx // write string
	xor    edx,edx
	invoke WriteFile, hFile, strNL, len_nl, esi, edx // write \n
	inc    ebx // next item
	cmp    ebx,items
	jb    .next

.invalid:
	call   FreeHeap, lpString
.closef:
	invoke CloseHandle, hFile

.quit:
	%undef items
	%undef hFile
	%undef lpString
	%undef boolUnicode
	%undef temp
	%undef apiSendMsg
	%undef apiStrLen
	%undef hwnd
	%undef strNL
	%undef len_nl
ENDPROC

//////////////////////////////////////////////////////////
// save to file list of properties
//////////////////////////////////////////////////////////
%define LVSTRLEN 1024

PROC SaveProperties, 12<<2 + LV_ITEM_size, hwnd
	LOCAL  items
	LOCAL  hFile
	LOCAL  lpString
	LOCAL  boolUnicode
	LOCAL  temp
	LOCAL  apiSendMsg // SendDlgItemMessageW or SendDlgItemMessageA
	LOCAL  apiStrlen  // lstrlenW or lstrlenA
	LOCAL  LVMGETITEM // LVM_GETITEMW or LVM_GETITEMA
	LOCAL  strNL
	LOCAL  len_nl
	LOCAL  strTAB
	LOCAL  len_tab
	LOCAL  lvi, LV_ITEM_size

	lea    esi,lvi
	xor    eax,eax
	mov    dword[esi+LV_ITEM.imask],LVIF_TEXT

	xor    eax,eax
	invoke SendDlgItemMessageW, hwnd, IDC_LSV1, LVM_GETITEMCOUNT, eax, eax
	mov    items,eax
	and    eax,eax
	jz     near .quit
	inc    eax
	jz     near .quit
	call   FileRequest, hwnd, 1, offset boolUnicode
	and    eax,eax
	jz     near .quit

	xor    eax,eax
	invoke CreateFileW, $wszOpenSavePath, GENERIC_WRITE,FILE_SHARE_READ, eax,\
		CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,eax
	mov    hFile,eax
	inc    eax
	jnz   .opened
	invoke MessageBoxW,hwnd,$wszCanNotOpenFile,eax,16
	jmp   .quit
.opened:
	lea    edi,temp // WriteFile bytes_writen

	mov    eax,boolUnicode
	mov    ecx,LVSTRLEN
	mov    edx,ecx
	add    edx,edx // LVSTRLEN*2
	and    eax,eax // unicode?
	cmovz  ecx,edx // size *2
	mov    dword[esi+LV_ITEM.cchTextMax],ecx
	call   AllocHeap, ecx
	mov    lpString,eax
	mov    dword[esi+LV_ITEM.pszText],eax
	and    eax,eax
	jz     near .closef

	extern SendDlgItemMessageA
	extern SendDlgItemMessageW
	extern lstrlenA
	extern lstrlenW

	mov    dword apiSendMsg,SendDlgItemMessageA // default ansi
	mov    dword strNL, $ansi_nl // 13,10
	mov    dword len_nl, 2
	mov    dword LVMGETITEM, LVM_GETITEMA
	mov    dword strTAB, $ansi_tab // 9
	mov    dword len_tab, 1
	mov    dword apiStrlen, lstrlenA

	xor    ebx,ebx      // ebx - combo string index
	cmp    dword boolUnicode,0
	jz    .next

	mov    dword apiSendMsg,SendDlgItemMessageW // else unicode

	mov    dword strNL, $wcha_nl
	mov    dword len_nl, 4
	mov    dword strTAB, $wcha_tab
	mov    dword len_tab, 2
	mov    dword apiStrlen, lstrlenW
	mov    dword LVMGETITEM, LVM_GETITEMW

	push   word 0xFEFF
	mov    eax,esp
	xor    edx,edx
	invoke WriteFile, hFile,eax,2,edi,edx // write unicode header
	pop    eax

.next:
	// subitem 0
	mov    dword[esi+LV_ITEM.iItem],ebx
	mov    dword[esi+LV_ITEM.iSubItem],0
	call   apiSendMsg, hwnd, IDC_LSV1, LVMGETITEM, 0, esi
	call   apiStrlen, lpString
	mov    ecx,eax
	add    ecx,ecx // ecx = strlen*2
	cmp    dword boolUnicode,0
	cmovnz eax,ecx
	xor    edx,edx
	invoke WriteFile, hFile, lpString, eax, edi, edx // write string

	xor    edx,edx
	invoke WriteFile, hFile, strTAB, len_tab, edi, edx // write \n
	// subitem 1
	inc    dword[esi+LV_ITEM.iSubItem]
	call   apiSendMsg, hwnd, IDC_LSV1, LVMGETITEM, 0, esi
	call   apiStrlen, lpString
	mov    ecx,eax
	add    ecx,ecx // ecx = strlen*2
	cmp    dword boolUnicode,0
	cmovnz eax,ecx
	xor    edx,edx
	invoke WriteFile, hFile, lpString, eax, edi, edx // write string

	xor    edx,edx
	invoke WriteFile, hFile, strNL, len_nl, edi, edx // write \n

	dec    dword[esi+LV_ITEM.iSubItem]
	inc    ebx // next item
	cmp    ebx,items
	jb    .next

.invalid:
	call   FreeHeap, lpString
.closef:
	invoke CloseHandle, hFile

.quit:
	%undef items
	%undef hFile
	%undef lpString
	%undef boolUnicode
	%undef temp
	%undef apiSendMsg
	%undef apiStrLen
	%undef hwnd
ENDPROC






%define ofnlen OPENFILENAME_size
%define USERFILTERLEN 128

PROC FileRequest, ofnlen, hwnd, boolSave, lpboolUnicode
	LOCAL ofn, ofnlen
	// clear the OPENFILENAME struct
	lea    edi, ofn
	mov    ecx, ofnlen/4
	xor    eax, eax
	rep    stosd


	lea    edi, ofn
	mov    dword[edi+OPENFILENAME.lStructSize],ofnlen
	mov    eax, hwnd
	mov    dword[edi+OPENFILENAME.hwndOwner],eax
;	mov    eax, [$g_hInstance]
;	mov    dword[edi+OPENFILENAME.hInstance],eax
	mov    dword[edi+OPENFILENAME.lpstrFilter],$wszSaveFilter
	mov    eax, [$nLastFilterIndex]
	mov    dword[edi+OPENFILENAME.nFilterIndex],eax
	mov    dword[edi+OPENFILENAME.lpstrFile],$wszOpenSavePath
	mov    dword[edi+OPENFILENAME.nMaxFile],260
	mov    dword[edi+OPENFILENAME.lpstrDefExt],$wszOpenSavDefExt
;	mov    dword[edi+OPENFILENAME.lpstrCustomFilter],$wszUserFilter
;	mov    dword[edi+OPENFILENAME.nMaxCustFilter],USERFILTERLEN
;	mov    eax,	[$nLastFilterIndex]
;	and    eax,eax
;	mov    edx,1
;	cmovz  eax,edx
	// lpstrFileTitle - returns file title [set nMaxFileTitle]

	// lpstrTitle


	mov    dword[edi+OPENFILENAME.Flags],OFN_ENABLESIZING|OFN_EXPLORER|OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST
	push   edi
	xor    eax,eax
	cmp    eax,boolSave
	extern GetOpenFileNameW
	extern GetSaveFileNameW
	mov    esi,GetSaveFileNameW
	mov    edx,GetOpenFileNameW
	cmovz  esi,edx
	call   esi
	// save filter index
;	and    eax,eax
;	jz    .quit
	mov    edx,[edi+OPENFILENAME.nFilterIndex]
	mov    [$nLastFilterIndex],edx
	mov    esi,lpboolUnicode
	and    edx,2
	mov    [esi],edx

	%undef hwnd
	%undef lpboolUnicode
	%undef boolSave
	%undef ofn
.quit:
ENDPROC

/////////////////////////////////////////////////////////////////////////////////


segment .data

align 4
$wszPropThreadData db "\LTHREADDATA"
align 4
$wszExecutingQuery db "\LExecuting query "
align 4
$wszSaveFilter     db "\LText Files (ansi)", "\L*.txt"
                   db "\LText Files (unicode)", "\L*.txt"
                   db "\LAll Files (ansi)", "\L*.*"
                   db "\LAll Files (unicode)", "\L*.*"
                   db "\L"
$wszTitle  db "\Lblah :P"
align 4
$wszOpenSavDefExt  db "\Ltxt"
$wszCanNotOpenFile db "\LCan not open file!"
$ansi_nl           db 13,10
$wcha_nl           dw 13,10
$ansi_tab          db 9
$wcha_tab          dw 9

align 4
$wszSplitterProp     db "\LSD"
$wszComboWProp       db "\LCW"
$wszInitialClassProp db "\LIC"
;$wshCursorProp       db "\LHC"


//$wszMyGuid    db "\LFFAEFE96-4D22-4DC5-BC9D-1605377FF1C2"
segment .bss
align 4
$wszUserFilter    resw USERFILTERLEN
align 4
$wszOpenSavePath  resw 260
$nLastFilterIndex resd 1
$hCursorArrow     resd 1
$hCursorSize      resd 1