%include "asm.inc"
global vtType2str

CIM_FLAG_ARRAY equ 0x2000

vtType2str:
	xor    eax,eax
	mov    [$def],eax
	mov    edx,[esp+4] // CIMTYPE
	push   esi
	push   edi
	mov    edi,_cimtype_table
	test   edx, CIM_FLAG_ARRAY
	jz    .next
	push   edx
	invoke lstrcpyW, $def, "\L/*array*/"
	pop    edx
	xor    edx,CIM_FLAG_ARRAY

	// skip string
.next:
	// save string pointer
	mov  esi,edi
	// no more?
	cmp  word[edi],0
	jz  .notfound
	mov  ecx,-1
	xor  ax,ax
	repne scasw
	// edi points to terminating null
	add edi,4  // go to next string
	cmp edx,[edi-4] // compare HRESULT
	jne .next
	// found!
	mov eax,esi
	jmp .quit

.notfound:
	cdecl swprintf, $def, "\L0x%X",edx

.quit:
	invoke lstrcatW, $def, eax
	mov   eax,$def
	pop   edi
	pop   esi
	ret   4


segment .data

_cimtype_table:

db "\LCIM_ILLEGAL"
dd 0xfff
db "\LCIM_EMPTY"
dd 0
db "\LCIM_SINT8"
dd 16
db "\LCIM_UINT8"
dd 17
db "\LCIM_SINT16"
dd 2
db "\LCIM_UINT16"
dd 18
db "\LCIM_SINT32"
dd 3
db "\LCIM_UINT32"
dd 19
db "\LCIM_SINT64"
dd 20
db "\LCIM_UINT64"
dd 21
db "\LCIM_REAL32"
dd 4
db "\LCIM_REAL64"
dd 5
db "\LCIM_BOOLEAN"
dd 11
db "\LCIM_STRING"
dd 8
db "\LCIM_DATETIME"
dd 101
db "\LCIM_REFERENCE"
dd 102
db "\LCIM_CHAR16"
dd 103
db "\LCIM_OBJECT"
dd 13
db "\LCIM_FLAG_ARRAY"
dd 0x2000

dw 0
dd 0

segment .bss
$def resw 256

