%include "asm.inc"
%include "variant.inc"

extern _CLSID_WbemAdministrativeLocator
extern _IID_IWbemLocator
extern _CLSID_WbemStatusCodeText
extern _IID_IWbemStatusCodeText

NULL equ 0
TRUE equ 1
RPC_C_AUTHN_LEVEL_PKT_PRIVACY equ 6
EOAC_SECURE_REFS equ 0x2
COINIT_MULTITHREADED equ 0
RPC_C_AUTHN_LEVEL_DEFAULT equ 0
RPC_C_IMP_LEVEL_IMPERSONATE equ 3
EOAC_NONE equ 0
CLSCTX_INPROC_SERVER equ 1
;WBEM_INFINITE equ 0xffffffff
;WBEM_FLAG_FORWARD_ONLY equ 0x20
WBEM_FLAG_CONNECT_USE_MAX_WAIT equ 0x80

INTERFACE IWbemLocator
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD ConnectServer
ENDINTERFACE

INTERFACE IWbemServices
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD OpenNamespace
	STDMETHOD CancelAsyncCall
	STDMETHOD QueryObjectSink
	STDMETHOD GetObject
	STDMETHOD GetObjectAsync
	STDMETHOD PutClass
	STDMETHOD PutClassAsync
	STDMETHOD DeleteClass
	STDMETHOD DeleteClassAsync
	STDMETHOD CreateClassEnum
	STDMETHOD CreateClassEnumAsync
	STDMETHOD PutInstance
	STDMETHOD PutInstanceAsync
	STDMETHOD DeleteInstance
	STDMETHOD DeleteInstanceAsync
	STDMETHOD CreateInstanceEnum
	STDMETHOD CreateInstanceEnumAsync
	STDMETHOD ExecQuery
	STDMETHOD ExecQueryAsync
	STDMETHOD ExecNotificationQuery
	STDMETHOD ExecNotificationQueryAsync
	STDMETHOD ExecMethod
	STDMETHOD ExecMethodAsync
ENDINTERFACE

INTERFACE IEnumWbemClassObject
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD Reset
	STDMETHOD Next
	STDMETHOD NextAsync
	STDMETHOD Clone
	STDMETHOD Skip
ENDINTERFACE

INTERFACE IWbemClassObject
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD GetQualifierSet
	STDMETHOD Get
	STDMETHOD Put
	STDMETHOD Delete
	STDMETHOD GetNames
	STDMETHOD BeginEnumeration
	STDMETHOD Next
	STDMETHOD EndEnumeration
	STDMETHOD GetPropertyQualifierSet
	STDMETHOD Clone
	STDMETHOD GetObjectText
	STDMETHOD SpawnDerivedClass
	STDMETHOD SpawnInstance
	STDMETHOD CompareTo
	STDMETHOD GetPropertyOrigin
	STDMETHOD InheritsFrom
	STDMETHOD GetMethod
	STDMETHOD PutMethod
	STDMETHOD DeleteMethod
	STDMETHOD BeginMethodEnumeration
	STDMETHOD NextMethod
	STDMETHOD EndMethodEnumeration
	STDMETHOD GetMethodQualifierSet
	STDMETHOD GetMethodOrigin
ENDINTERFACE

INTERFACE IWbemStatusCodeText
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD GetErrorCodeText
	STDMETHOD GetFacilityCodeText
ENDINTERFACE


	WBEM_GENUS_CLASS equ 1
	WBEM_GENUS_INSTANCE equ 2
// 	WBEM_GENUS_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_CHANGE_FLAG_TYPE
	WBEM_FLAG_CREATE_OR_UPDATE equ 0
	WBEM_FLAG_UPDATE_ONLY equ 0x1
	WBEM_FLAG_CREATE_ONLY equ 0x2
	WBEM_FLAG_UPDATE_COMPATIBLE equ 0
	WBEM_FLAG_UPDATE_SAFE_MODE equ 0x20
	WBEM_FLAG_UPDATE_FORCE_MODE equ 0x40
	WBEM_MASK_UPDATE_MODE equ 0x60
	WBEM_FLAG_ADVISORY equ 0x10000
// 	WBEM_CHANGE_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_GENERIC_FLAG_TYPE
	WBEM_FLAG_RETURN_IMMEDIATELY equ 0x10
	WBEM_FLAG_RETURN_WBEM_COMPLETE equ 0
	WBEM_FLAG_BIDIRECTIONAL equ 0
	WBEM_FLAG_FORWARD_ONLY equ 0x20
	WBEM_FLAG_NO_ERROR_OBJECT equ 0x40
	WBEM_FLAG_RETURN_ERROR_OBJECT equ 0
	WBEM_FLAG_SEND_STATUS equ 0x80
	WBEM_FLAG_DONT_SEND_STATUS equ 0
	WBEM_FLAG_ENSURE_LOCATABLE equ 0x100
	WBEM_FLAG_DIRECT_READ equ 0x200
	WBEM_FLAG_SEND_ONLY_SELECTED equ 0
	WBEM_RETURN_WHEN_COMPLETE equ 0
	WBEM_RETURN_IMMEDIATELY equ 0x10
	WBEM_MASK_RESERVED_FLAGS equ 0x1f000
	WBEM_FLAG_USE_AMENDED_QUALIFIERS equ 0x20000
	WBEM_FLAG_STRONG_VALIDATION equ 0x100000
// 	WBEM_GENERIC_FLAG_TYPE;

//typedef 
//enum WBEM_STATUS_TYPE
	WBEM_STATUS_COMPLETE equ 0
	WBEM_STATUS_REQUIREMENTS equ 1
	WBEM_STATUS_PROGRESS equ 2
// 	WBEM_STATUS_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_TIMEOUT_TYPE
	WBEM_NO_WAIT equ 0
	WBEM_INFINITE equ 0xffffffff
// 	WBEM_TIMEOUT_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_CONDITION_FLAG_TYPE
	WBEM_FLAG_ALWAYS equ 0
	WBEM_FLAG_ONLY_IF_TRUE equ 0x1
	WBEM_FLAG_ONLY_IF_FALSE equ 0x2
	WBEM_FLAG_ONLY_IF_IDENTICAL equ 0x3
	WBEM_MASK_PRIMARY_CONDITION equ 0x3
	WBEM_FLAG_KEYS_ONLY equ 0x4
	WBEM_FLAG_REFS_ONLY equ 0x8
	WBEM_FLAG_LOCAL_ONLY equ 0x10
	WBEM_FLAG_PROPAGATED_ONLY equ 0x20
	WBEM_FLAG_SYSTEM_ONLY equ 0x30
	WBEM_FLAG_NONSYSTEM_ONLY equ 0x40
	WBEM_MASK_CONDITION_ORIGIN equ 0x70
	WBEM_FLAG_CLASS_OVERRIDES_ONLY equ 0x100
	WBEM_FLAG_CLASS_LOCAL_AND_OVERRIDES equ 0x200
	WBEM_MASK_CLASS_CONDITION equ 0x300
// 	WBEM_CONDITION_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_FLAVOR_TYPE
	WBEM_FLAVOR_DONT_PROPAGATE equ 0
	WBEM_FLAVOR_FLAG_PROPAGATE_TO_INSTANCE equ 0x1
	WBEM_FLAVOR_FLAG_PROPAGATE_TO_DERIVED_CLASS equ 0x2
	WBEM_FLAVOR_MASK_PROPAGATION equ 0xf
	WBEM_FLAVOR_OVERRIDABLE equ 0
	WBEM_FLAVOR_NOT_OVERRIDABLE equ 0x10
	WBEM_FLAVOR_MASK_PERMISSIONS equ 0x10
	WBEM_FLAVOR_ORIGIN_LOCAL equ 0
	WBEM_FLAVOR_ORIGIN_PROPAGATED equ 0x20
	WBEM_FLAVOR_ORIGIN_SYSTEM equ 0x40
	WBEM_FLAVOR_MASK_ORIGIN equ 0x60
	WBEM_FLAVOR_NOT_AMENDED equ 0
	WBEM_FLAVOR_AMENDED equ 0x80
	WBEM_FLAVOR_MASK_AMENDED equ 0x80
// 	WBEM_FLAVOR_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_QUERY_FLAG_TYPE
	WBEM_FLAG_DEEP equ 0
	WBEM_FLAG_SHALLOW equ 1
	WBEM_FLAG_PROTOTYPE equ 2
// 	WBEM_QUERY_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_SECURITY_FLAGS
	WBEM_ENABLE equ 1
	WBEM_METHOD_EXECUTE equ 2
	WBEM_FULL_WRITE_REP equ 4
	WBEM_PARTIAL_WRITE_REP equ 8
	WBEM_WRITE_PROVIDER equ 0x10
	WBEM_REMOTE_ACCESS equ 0x20
	WBEM_RIGHT_SUBSCRIBE equ 0x40
	WBEM_RIGHT_PUBLISH equ 0x80
// 	WBEM_SECURITY_FLAGS;

//typedef /* [v1_enum] */ 
//enum WBEM_LIMITATION_FLAG_TYPE
	WBEM_FLAG_EXCLUDE_OBJECT_QUALIFIERS equ 0x10
	WBEM_FLAG_EXCLUDE_PROPERTY_QUALIFIERS equ 0x20
// 	WBEM_LIMITATION_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_TEXT_FLAG_TYPE
	WBEM_FLAG_NO_FLAVORS equ 0x1
// 	WBEM_TEXT_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum WBEM_COMPARISON_FLAG
	WBEM_COMPARISON_INCLUDE_ALL equ 0
	WBEM_FLAG_IGNORE_QUALIFIERS equ 0x1
	WBEM_FLAG_IGNORE_OBJECT_SOURCE equ 0x2
	WBEM_FLAG_IGNORE_DEFAULT_VALUES equ 0x4
	WBEM_FLAG_IGNORE_CLASS equ 0x8
	WBEM_FLAG_IGNORE_CASE equ 0x10
	WBEM_FLAG_IGNORE_FLAVOR equ 0x20
// 	WBEM_COMPARISON_FLAG;

//typedef /* [v1_enum] */ 
//enum WBEM_LOCKING
	WBEM_FLAG_ALLOW_READ equ 0x1
// 	WBEM_LOCKING_FLAG_TYPE;

//typedef /* [v1_enum] */ 
//enum CIMTYPE_ENUMERATION
	CIM_ILLEGAL equ 0xfff
	CIM_EMPTY equ 0
	CIM_SINT8 equ 16
	CIM_UINT8 equ 17
	CIM_SINT16 equ 2
	CIM_UINT16 equ 18
	CIM_SINT32 equ 3
	CIM_UINT32 equ 19
	CIM_SINT64 equ 20
	CIM_UINT64 equ 21
	CIM_REAL32 equ 4
	CIM_REAL64 equ 5
	CIM_BOOLEAN equ 11
	CIM_STRING equ 8
	CIM_DATETIME equ 101
	CIM_REFERENCE equ 102
	CIM_CHAR16 equ 103
	CIM_OBJECT equ 13
	CIM_FLAG_ARRAY equ 0x2000
// 	CIMTYPE_ENUMERATION;

//typedef /* [v1_enum] */ 
//enum WBEM_BACKUP_RESTORE_FLAGS
	WBEM_FLAG_BACKUP_RESTORE_DEFAULT equ 0
	WBEM_FLAG_BACKUP_RESTORE_FORCE_SHUTDOWN equ 1
// 	WBEM_BACKUP_RESTORE_FLAGS;

//typedef /* [v1_enum] */ 
//enum WBEM_REFRESHER_FLAGS
	WBEM_FLAG_REFRESH_AUTO_RECONNECT equ 0
	WBEM_FLAG_REFRESH_NO_AUTO_RECONNECT equ 1
// 	WBEM_REFRESHER_FLAGS;

//typedef 
//enum WBEM_SHUTDOWN_FLAGS
	WBEM_SHUTDOWN_UNLOAD_COMPONENT equ 1
	WBEM_SHUTDOWN_WMI equ 2
	WBEM_SHUTDOWN_OS equ 3
// 	WBEM_SHUTDOWN_FLAGS;

//typedef long CIMTYPE;

//typedef /* [v1_enum] */ 
//enum WBEMSTATUS_FORMAT
	WBEMSTATUS_FORMAT_NEWLINE equ 0
	WBEMSTATUS_FORMAT_NO_NEWLINE equ 1
// 	WBEMSTATUS_FORMAT;

//typedef /* [v1_enum] */ 
//enum WBEM_LIMITS
	WBEM_MAX_IDENTIFIER equ 0x1000
	WBEM_MAX_QUERY equ 0x4000
	WBEM_MAX_PATH equ 0x2000
	WBEM_MAX_OBJECT_NESTING equ 64
	WBEM_MAX_USER_PROPERTIES equ 1024
// 	WBEM_LIMITS;

//typedef /* [v1_enum] */ 
//enum WBEMSTATUS
	WBEM_NO_ERROR equ 0
	WBEM_S_NO_ERROR equ 0
	WBEM_S_SAME equ 0
	WBEM_S_FALSE equ 1
	WBEM_S_ALREADY_EXISTS equ 0x40001
	WBEM_S_RESET_TO_DEFAULT equ 0x40002
	WBEM_S_DIFFERENT equ 0x40003
	WBEM_S_TIMEDOUT equ 0x40004
	WBEM_S_NO_MORE_DATA equ 0x40005
	WBEM_S_OPERATION_CANCELLED equ 0x40006
	WBEM_S_PENDING equ 0x40007
	WBEM_S_DUPLICATE_OBJECTS equ 0x40008
	WBEM_S_ACCESS_DENIED equ 0x40009
	WBEM_S_PARTIAL_RESULTS equ 0x40010
	WBEM_S_SOURCE_NOT_AVAILABLE equ 0x40017
	WBEM_E_FAILED equ 0x80041001
	WBEM_E_NOT_FOUND equ 0x80041002
	WBEM_E_ACCESS_DENIED equ 0x80041003
	WBEM_E_PROVIDER_FAILURE equ 0x80041004
	WBEM_E_TYPE_MISMATCH equ 0x80041005
	WBEM_E_OUT_OF_MEMORY equ 0x80041006
	WBEM_E_INVALID_CONTEXT equ 0x80041007
	WBEM_E_INVALID_PARAMETER equ 0x80041008
	WBEM_E_NOT_AVAILABLE equ 0x80041009
	WBEM_E_CRITICAL_ERROR equ 0x8004100a
	WBEM_E_INVALID_STREAM equ 0x8004100b
	WBEM_E_NOT_SUPPORTED equ 0x8004100c
	WBEM_E_INVALID_SUPERCLASS equ 0x8004100d
	WBEM_E_INVALID_NAMESPACE equ 0x8004100e
	WBEM_E_INVALID_OBJECT equ 0x8004100f
	WBEM_E_INVALID_CLASS equ 0x80041010
	WBEM_E_PROVIDER_NOT_FOUND equ 0x80041011
	WBEM_E_INVALID_PROVIDER_REGISTRATION equ 0x80041012
	WBEM_E_PROVIDER_LOAD_FAILURE equ 0x80041013
	WBEM_E_INITIALIZATION_FAILURE equ 0x80041014
	WBEM_E_TRANSPORT_FAILURE equ 0x80041015
	WBEM_E_INVALID_OPERATION equ 0x80041016
	WBEM_E_INVALID_QUERY equ 0x80041017
	WBEM_E_INVALID_QUERY_TYPE equ 0x80041018
	WBEM_E_ALREADY_EXISTS equ 0x80041019
	WBEM_E_OVERRIDE_NOT_ALLOWED equ 0x8004101a
	WBEM_E_PROPAGATED_QUALIFIER equ 0x8004101b
	WBEM_E_PROPAGATED_PROPERTY equ 0x8004101c
	WBEM_E_UNEXPECTED equ 0x8004101d
	WBEM_E_ILLEGAL_OPERATION equ 0x8004101e
	WBEM_E_CANNOT_BE_KEY equ 0x8004101f
	WBEM_E_INCOMPLETE_CLASS equ 0x80041020
	WBEM_E_INVALID_SYNTAX equ 0x80041021
	WBEM_E_NONDECORATED_OBJECT equ 0x80041022
	WBEM_E_READ_ONLY equ 0x80041023
	WBEM_E_PROVIDER_NOT_CAPABLE equ 0x80041024
	WBEM_E_CLASS_HAS_CHILDREN equ 0x80041025
	WBEM_E_CLASS_HAS_INSTANCES equ 0x80041026
	WBEM_E_QUERY_NOT_IMPLEMENTED equ 0x80041027
	WBEM_E_ILLEGAL_NULL equ 0x80041028
	WBEM_E_INVALID_QUALIFIER_TYPE equ 0x80041029
	WBEM_E_INVALID_PROPERTY_TYPE equ 0x8004102a
	WBEM_E_VALUE_OUT_OF_RANGE equ 0x8004102b
	WBEM_E_CANNOT_BE_SINGLETON equ 0x8004102c
	WBEM_E_INVALID_CIM_TYPE equ 0x8004102d
	WBEM_E_INVALID_METHOD equ 0x8004102e
	WBEM_E_INVALID_METHOD_PARAMETERS equ 0x8004102f
	WBEM_E_SYSTEM_PROPERTY equ 0x80041030
	WBEM_E_INVALID_PROPERTY equ 0x80041031
	WBEM_E_CALL_CANCELLED equ 0x80041032
	WBEM_E_SHUTTING_DOWN equ 0x80041033
	WBEM_E_PROPAGATED_METHOD equ 0x80041034
	WBEM_E_UNSUPPORTED_PARAMETER equ 0x80041035
	WBEM_E_MISSING_PARAMETER_ID equ 0x80041036
	WBEM_E_INVALID_PARAMETER_ID equ 0x80041037
	WBEM_E_NONCONSECUTIVE_PARAMETER_IDS equ 0x80041038
	WBEM_E_PARAMETER_ID_ON_RETVAL equ 0x80041039
	WBEM_E_INVALID_OBJECT_PATH equ 0x8004103a
	WBEM_E_OUT_OF_DISK_SPACE equ 0x8004103b
	WBEM_E_BUFFER_TOO_SMALL equ 0x8004103c
	WBEM_E_UNSUPPORTED_PUT_EXTENSION equ 0x8004103d
	WBEM_E_UNKNOWN_OBJECT_TYPE equ 0x8004103e
	WBEM_E_UNKNOWN_PACKET_TYPE equ 0x8004103f
	WBEM_E_MARSHAL_VERSION_MISMATCH equ 0x80041040
	WBEM_E_MARSHAL_INVALID_SIGNATURE equ 0x80041041
	WBEM_E_INVALID_QUALIFIER equ 0x80041042
	WBEM_E_INVALID_DUPLICATE_PARAMETER equ 0x80041043
	WBEM_E_TOO_MUCH_DATA equ 0x80041044
	WBEM_E_SERVER_TOO_BUSY equ 0x80041045
	WBEM_E_INVALID_FLAVOR equ 0x80041046
	WBEM_E_CIRCULAR_REFERENCE equ 0x80041047
	WBEM_E_UNSUPPORTED_CLASS_UPDATE equ 0x80041048
	WBEM_E_CANNOT_CHANGE_KEY_INHERITANCE equ 0x80041049
	WBEM_E_CANNOT_CHANGE_INDEX_INHERITANCE equ 0x80041050
	WBEM_E_TOO_MANY_PROPERTIES equ 0x80041051
	WBEM_E_UPDATE_TYPE_MISMATCH equ 0x80041052
	WBEM_E_UPDATE_OVERRIDE_NOT_ALLOWED equ 0x80041053
	WBEM_E_UPDATE_PROPAGATED_METHOD equ 0x80041054
	WBEM_E_METHOD_NOT_IMPLEMENTED equ 0x80041055
	WBEM_E_METHOD_DISABLED equ 0x80041056
	WBEM_E_REFRESHER_BUSY equ 0x80041057
	WBEM_E_UNPARSABLE_QUERY equ 0x80041058
	WBEM_E_NOT_EVENT_CLASS equ 0x80041059
	WBEM_E_MISSING_GROUP_WITHIN equ 0x8004105a
	WBEM_E_MISSING_AGGREGATION_LIST equ 0x8004105b
	WBEM_E_PROPERTY_NOT_AN_OBJECT equ 0x8004105c
	WBEM_E_AGGREGATING_BY_OBJECT equ 0x8004105d
	WBEM_E_UNINTERPRETABLE_PROVIDER_QUERY equ 0x8004105f
	WBEM_E_BACKUP_RESTORE_WINMGMT_RUNNING equ 0x80041060
	WBEM_E_QUEUE_OVERFLOW equ 0x80041061
	WBEM_E_PRIVILEGE_NOT_HELD equ 0x80041062
	WBEM_E_INVALID_OPERATOR equ 0x80041063
	WBEM_E_LOCAL_CREDENTIALS equ 0x80041064
	WBEM_E_CANNOT_BE_ABSTRACT equ 0x80041065
	WBEM_E_AMENDED_OBJECT equ 0x80041066
	WBEM_E_CLIENT_TOO_SLOW equ 0x80041067
	WBEM_E_NULL_SECURITY_DESCRIPTOR equ 0x80041068
	WBEM_E_TIMED_OUT equ 0x80041069
	WBEM_E_INVALID_ASSOCIATION equ 0x8004106a
	WBEM_E_AMBIGUOUS_OPERATION equ 0x8004106b
	WBEM_E_QUOTA_VIOLATION equ 0x8004106c
	WBEM_E_RESERVED_001 equ 0x8004106d
	WBEM_E_RESERVED_002 equ 0x8004106e
	WBEM_E_UNSUPPORTED_LOCALE equ 0x8004106f
	WBEM_E_HANDLE_OUT_OF_DATE equ 0x80041070
	WBEM_E_CONNECTION_FAILED equ 0x80041071
	WBEM_E_INVALID_HANDLE_REQUEST equ 0x80041072
	WBEM_E_PROPERTY_NAME_TOO_WIDE equ 0x80041073
	WBEM_E_CLASS_NAME_TOO_WIDE equ 0x80041074
	WBEM_E_METHOD_NAME_TOO_WIDE equ 0x80041075
	WBEM_E_QUALIFIER_NAME_TOO_WIDE equ 0x80041076
	WBEM_E_RERUN_COMMAND equ 0x80041077
	WBEM_E_DATABASE_VER_MISMATCH equ 0x80041078
	WBEM_E_VETO_DELETE equ 0x80041079
	WBEM_E_VETO_PUT equ 0x8004107a
	WBEM_E_INVALID_LOCALE equ 0x80041080
	WBEM_E_PROVIDER_SUSPENDED equ 0x80041081
	WBEM_E_SYNCHRONIZATION_REQUIRED equ 0x80041082
	WBEM_E_NO_SCHEMA equ 0x80041083
	WBEM_E_PROVIDER_ALREADY_REGISTERED equ 0x80041084
	WBEM_E_PROVIDER_NOT_REGISTERED equ 0x80041085
	WBEM_E_FATAL_TRANSPORT_ERROR equ 0x80041086
	WBEM_E_ENCRYPTED_CONNECTION_REQUIRED equ 0x80041087
	WBEM_E_PROVIDER_TIMED_OUT equ 0x80041088
	WBEM_E_NO_KEY equ 0x80041089
	WBEM_E_PROVIDER_DISABLED equ 0x8004108a
	WBEMESS_E_REGISTRATION_TOO_BROAD equ 0x80042001
	WBEMESS_E_REGISTRATION_TOO_PRECISE equ 0x80042002
	WBEMESS_E_AUTHZ_NOT_PRIVILEGED equ 0x80042003
	WBEMMOF_E_EXPECTED_QUALIFIER_NAME equ 0x80044001
	WBEMMOF_E_EXPECTED_SEMI equ 0x80044002
	WBEMMOF_E_EXPECTED_OPEN_BRACE equ 0x80044003
	WBEMMOF_E_EXPECTED_CLOSE_BRACE equ 0x80044004
	WBEMMOF_E_EXPECTED_CLOSE_BRACKET equ 0x80044005
	WBEMMOF_E_EXPECTED_CLOSE_PAREN equ 0x80044006
	WBEMMOF_E_ILLEGAL_CONSTANT_VALUE equ 0x80044007
	WBEMMOF_E_EXPECTED_TYPE_IDENTIFIER equ 0x80044008
	WBEMMOF_E_EXPECTED_OPEN_PAREN equ 0x80044009
	WBEMMOF_E_UNRECOGNIZED_TOKEN equ 0x8004400a
	WBEMMOF_E_UNRECOGNIZED_TYPE equ 0x8004400b
	WBEMMOF_E_EXPECTED_PROPERTY_NAME equ 0x8004400c
	WBEMMOF_E_//typedef_NOT_SUPPORTED equ 0x8004400d
	WBEMMOF_E_UNEXPECTED_ALIAS equ 0x8004400e
	WBEMMOF_E_UNEXPECTED_ARRAY_INIT equ 0x8004400f
	WBEMMOF_E_INVALID_AMENDMENT_SYNTAX equ 0x80044010
	WBEMMOF_E_INVALID_DUPLICATE_AMENDMENT equ 0x80044011
	WBEMMOF_E_INVALID_PRAGMA equ 0x80044012
	WBEMMOF_E_INVALID_NAMESPACE_SYNTAX equ 0x80044013
	WBEMMOF_E_EXPECTED_CLASS_NAME equ 0x80044014
	WBEMMOF_E_TYPE_MISMATCH equ 0x80044015
	WBEMMOF_E_EXPECTED_ALIAS_NAME equ 0x80044016
	WBEMMOF_E_INVALID_CLASS_DECLARATION equ 0x80044017
	WBEMMOF_E_INVALID_INSTANCE_DECLARATION equ 0x80044018
	WBEMMOF_E_EXPECTED_DOLLAR equ 0x80044019
	WBEMMOF_E_CIMTYPE_QUALIFIER equ 0x8004401a
	WBEMMOF_E_DUPLICATE_PROPERTY equ 0x8004401b
	WBEMMOF_E_INVALID_NAMESPACE_SPECIFICATION equ 0x8004401c
	WBEMMOF_E_OUT_OF_RANGE equ 0x8004401d
	WBEMMOF_E_INVALID_FILE equ 0x8004401e
	WBEMMOF_E_ALIASES_IN_EMBEDDED equ 0x8004401f
	WBEMMOF_E_NULL_ARRAY_ELEM equ 0x80044020
	WBEMMOF_E_DUPLICATE_QUALIFIER equ 0x80044021
	WBEMMOF_E_EXPECTED_FLAVOR_TYPE equ 0x80044022
	WBEMMOF_E_INCOMPATIBLE_FLAVOR_TYPES equ 0x80044023
	WBEMMOF_E_MULTIPLE_ALIASES equ 0x80044024
	WBEMMOF_E_INCOMPATIBLE_FLAVOR_TYPES2 equ 0x80044025
	WBEMMOF_E_NO_ARRAYS_RETURNED equ 0x80044026
	WBEMMOF_E_MUST_BE_IN_OR_OUT equ 0x80044027
	WBEMMOF_E_INVALID_FLAGS_SYNTAX equ 0x80044028
	WBEMMOF_E_EXPECTED_BRACE_OR_BAD_TYPE equ 0x80044029
	WBEMMOF_E_UNSUPPORTED_CIMV22_QUAL_VALUE equ 0x8004402a
	WBEMMOF_E_UNSUPPORTED_CIMV22_DATA_TYPE equ 0x8004402b
	WBEMMOF_E_INVALID_DELETEINSTANCE_SYNTAX equ 0x8004402c
	WBEMMOF_E_INVALID_QUALIFIER_SYNTAX equ 0x8004402d
	WBEMMOF_E_QUALIFIER_USED_OUTSIDE_SCOPE equ 0x8004402e
	WBEMMOF_E_ERROR_CREATING_TEMP_FILE equ 0x8004402f
	WBEMMOF_E_ERROR_INVALID_INCLUDE_FILE equ 0x80044030
	WBEMMOF_E_INVALID_DELETECLASS_SYNTAX equ 0x80044031
